c HPLS from HPOLY
*     J. Ablinger, J. Bl\"umlein, M. Round and C. Schneider
*     Numerical Implementation of Harmonic Polylogarithms to Weight w = 8
*     DESY 13-064, DO-TH 17/12, arXive:1809.07084 [hep-ph].
c Modified by Leandro Cieri 03/08/2020

c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             HPLS  Peso 5 Basis From Bl\"umlein
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      function HB01111(x) !B1
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB01111 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB01111 = HB5(0,1,1,1,1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB01111 =     -HB00001(y) - HBm10000(y) - HBm11000(y) - HBm1m1000(y) - HBm1m1100(y) - 
     -  HBm1m1m100(y) - HBm1m1m110(y) - HBm1m1m1m10(y) - HBm1m1m1m11(y) - 
     -  H4(y)*Hm1(y) + HBm1100(y)*Hm1(y) + HBm1m110(y)*Hm1(y) - 
     -  (H3h(y)*Hm1(y)**2)/2. - (H2h(y)*Hm1(y)**3)/6. - (H1h(y)*Hm1(y)**4)/24. - 
     -  Hm1(y)**5/120. + (Hm1(y)**3*Hm10(y))/6. - (Hm1(y)**2*Hm100(y))/2. + 
     -  Hm1(y)*Hm1000(y) + (Hm1(y)**3*Hm11(y))/6. - (Hm1(y)**2*Hm110(y))/2. - 
     -  (Hm1(y)**2*Hm1m10(y))/2. + Hm1(y)*Hm1m100(y) - (Hm1(y)**2*Hm1m11(y))/2. + 
     -  Hm1(y)*Hm1m1m10(y) + Hm1(y)*Hm1m1m11(y) + H4(y)*Ho(y) + H3h(y)*Hm1(y)*Ho(y) + 
     -  (H2h(y)*Hm1(y)**2*Ho(y))/2. + (H1h(y)*Hm1(y)**3*Ho(y))/6. - 
     -  (H3h(y)*Ho(y)**2)/2. - (H2h(y)*Hm1(y)*Ho(y)**2)/2. - 
     -  (H1h(y)*Hm1(y)**2*Ho(y)**2)/4. + (H2h(y)*Ho(y)**3)/6. + 
     -  (H1h(y)*Hm1(y)*Ho(y)**3)/6. - (H1h(y)*Ho(y)**4)/24. + H4(y)*Log(2._dp) - 
     -  HBm1100(y)*Log(2._dp) - HBm1m110(y)*Log(2._dp) + H3h(y)*Hm1(y)*Log(2._dp) + 
     -  (H2h(y)*Hm1(y)**2*Log(2._dp))/2. + (H1h(y)*Hm1(y)**3*Log(2._dp))/6. + 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. + 
     -  Hm1(y)*Hm100(y)*Log(2._dp) - Hm1000(y)*Log(2._dp) - (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. + 
     -  Hm1(y)*Hm110(y)*Log(2._dp) + Hm1(y)*Hm1m10(y)*Log(2._dp) - Hm1m100(y)*Log(2._dp) + 
     -  Hm1(y)*Hm1m11(y)*Log(2._dp) - Hm1m1m10(y)*Log(2._dp) - Hm1m1m11(y)*Log(2._dp) - 
     -  H3h(y)*Ho(y)*Log(2._dp) - H2h(y)*Hm1(y)*Ho(y)*Log(2._dp) - 
     -  (H1h(y)*Hm1(y)**2*Ho(y)*Log(2._dp))/2. + (H2h(y)*Ho(y)**2*Log(2._dp))/2. + 
     -  (H1h(y)*Hm1(y)*Ho(y)**2*Log(2._dp))/2. - (H1h(y)*Ho(y)**3*Log(2._dp))/6. - 
     -  (H3h(y)*Log(2._dp)**2)/2. - (H2h(y)*Hm1(y)*Log(2._dp)**2)/2. - 
     -  (H1h(y)*Hm1(y)**2*Log(2._dp)**2)/4. - (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1(y)*Hm10(y)*Log(2._dp)**2)/2. - (Hm100(y)*Log(2._dp)**2)/2. + 
     -  (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. - (Hm110(y)*Log(2._dp)**2)/2. - 
     -  (Hm1m10(y)*Log(2._dp)**2)/2. - (Hm1m11(y)*Log(2._dp)**2)/2. + 
     -  (H2h(y)*Ho(y)*Log(2._dp)**2)/2. + (H1h(y)*Hm1(y)*Ho(y)*Log(2._dp)**2)/2. - 
     -  (H1h(y)*Ho(y)**2*Log(2._dp)**2)/4. + (H2h(y)*Log(2._dp)**3)/6. + 
     -  (H1h(y)*Hm1(y)*Log(2._dp)**3)/6. + (Hm1(y)**2*Log(2._dp)**3)/12. - 
     -  (Hm10(y)*Log(2._dp)**3)/6. - (Hm11(y)*Log(2._dp)**3)/6. - 
     -  (H1h(y)*Ho(y)*Log(2._dp)**3)/6. - (H1h(y)*Log(2._dp)**4)/24. - 
     -  (Hm1(y)*Log(2._dp)**4)/24. + Zeta(5) 
      
      else
      write(*,*)' x out of range HB01111.  x = ',x
      endif
      
      return
      end 


      function HB01011(x) !B2
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB01011 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB01011 = HB5(0,1,0,1,1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB01011 = (Pi**4*H1h(y))/30._dp + H2h(y)*H3h(y) - 3._dp*H1h(y)*H4(y) - HB00101(y) - 
     -  3._dp*HBm10001(y) - 2._dp*HBm10010(y) + HBm100m11(y) - 2._dp*HBm10100(y) - HBm10m100(y) + 
     -  HBm10m101(y) + 3._dp*H1h(y)*HBm1100(y) - 3*HBm11001(y) - 2._dp*HBm11010(y) - 
     -  2._dp*HBm11100(y) - HBm11m110(y) - HBm1m1001(y) - 2._dp*HBm1m1010(y) + HBm1m10m10(y) + 
     -  HBm1m10m11(y) + 3._dp*H1h(y)*HBm1m110(y) + 2*HBm1m1100(y) - 3._dp*HBm1m1101(y) - 
     -  4._dp*HBm1m1110(y) + HBm1m11m10(y) + HBm1m11m11(y) + 7*HBm1m1m100(y) + 
     -  7._dp*HBm1m1m110(y) + 7._dp*HBm1m1m1m10(y) + 7*HBm1m1m1m11(y) + (Pi**4*Hm1(y))/30._dp + 
     -  (H2h(y)**2*Hm1(y))/2._dp + 2._dp*H31(y)*Hm1(y) - 2*H1h(y)*H3h(y)*Hm1(y) + 
     -  2._dp*HBm1101(y)*Hm1(y) + 2._dp*HBm1110(y)*Hm1(y) - 2*HBm1m110(y)*Hm1(y) + 
     -  2._dp*HBm1m111(y)*Hm1(y) + H21(y)*Hm1(y)**2 - (H1h(y)*H2h(y)*Hm1(y)**2)/2._dp + 
     -  (H2h(y)*Hm1(y)**3)/6._dp + (H1h(y)*Hm1(y)**4)/24._dp + Hm1(y)**5/120._dp - 
     -  H2h(y)*Hm1(y)*Hm10(y) + (H1h(y)*Hm1(y)**2*Hm10(y))/2._dp - 
     -  (Hm1(y)**3*Hm10(y))/6._dp + (Hm1(y)*Hm10(y)**2)/2._dp + H2h(y)*Hm100(y) - 
     -  2*H1h(y)*Hm1(y)*Hm100(y) + 3._dp*H1h(y)*Hm1000(y) - H2h(y)*Hm1(y)*Hm11(y) + 
     -  (H1h(y)*Hm1(y)**2*Hm11(y))/2._dp - (Hm1(y)**3*Hm11(y))/6._dp + 
     -  Hm1(y)*Hm10(y)*Hm11(y) - Hm100(y)*Hm11(y) + (Hm1(y)*Hm11(y)**2)/2._dp + 
     -  H2h(y)*Hm110(y) - 2._dp*H1h(y)*Hm1(y)*Hm110(y) - Hm1(y)**2*Hm111(y) - 
     -  Hm1(y)**2*Hm12(y) + 2*Hm1(y)*Hm120(y) + 2*Hm1(y)*Hm13(y) + H2h(y)*Hm1m10(y) - 
     -  2._dp*H1h(y)*Hm1(y)*Hm1m10(y) + Hm1(y)**2*Hm1m10(y) - Hm10(y)*Hm1m10(y) - 
     -  Hm11(y)*Hm1m10(y) + 3._dp*H1h(y)*Hm1m100(y) - 2*Hm1(y)*Hm1m100(y) + 
     -  H2h(y)*Hm1m11(y) - 2._dp*H1h(y)*Hm1(y)*Hm1m11(y) + Hm1(y)**2*Hm1m11(y) - 
     -  Hm10(y)*Hm1m11(y) - Hm11(y)*Hm1m11(y) + 2*Hm1(y)*Hm1m12(y) + 
     -  3._dp*H1h(y)*Hm1m1m10(y) - 4._dp*Hm1(y)*Hm1m1m10(y) + 3*H1h(y)*Hm1m1m11(y) - 
     -  4._dp*Hm1(y)*Hm1m1m11(y) - (H2h(y)**2*Ho(y))/2. - 2*H31(y)*Ho(y) + 
     -  2._dp*H1h(y)*H3h(y)*Ho(y) - 2._dp*H21(y)*Hm1(y)*Ho(y) + H1h(y)*H2h(y)*Hm1(y)*Ho(y) - 
     -  (H1h(y)*Hm1(y)**3*Ho(y))/6._dp + H1h(y)*Hm1(y)*Hm10(y)*Ho(y) - 
     -  H1h(y)*Hm100(y)*Ho(y) + H1h(y)*Hm1(y)*Hm11(y)*Ho(y) - H1h(y)*Hm110(y)*Ho(y) - 
     -  H1h(y)*Hm1m10(y)*Ho(y) - H1h(y)*Hm1m11(y)*Ho(y) + H21(y)*Ho(y)**2 - 
     -  (H1h(y)*H2h(y)*Ho(y)**2)/2._dp - (H2h(y)**2*Log(2._dp))/2._dp - 2*H31(y)*Log(2._dp) + 
     -  2._dp*H1h(y)*H3h(y)*Log(2._dp) - 2._dp*HBm1101(y)*Log(2._dp) - 2*HBm1110(y)*Log(2._dp) + 
     -  2._dp*HBm1m110(y)*Log(2._dp) - 2*HBm1m111(y)*Log(2._dp) - 2*H21(y)*Hm1(y)*Log(2._dp) + 
     -  H1h(y)*H2h(y)*Hm1(y)*Log(2._dp) - (H2h(y)*Hm1(y)**2*Log(2._dp))/2._dp - 
     -  (H1h(y)*Hm1(y)**3*Log(2._dp))/6._dp - (Hm1(y)**4*Log(2._dp))/24._dp + 
     -  H2h(y)*Hm10(y)*Log(2._dp) - H1h(y)*Hm1(y)*Hm10(y)*Log(2._dp) + 
     -  (Hm1(y)**2*Hm10(y)*Log(2._dp))/2._dp - (Hm10(y)**2*Log(2._dp))/2._dp + 
     -  2._dp*H1h(y)*Hm100(y)*Log(2._dp) + H2h(y)*Hm11(y)*Log(2._dp) - 
     -  H1h(y)*Hm1(y)*Hm11(y)*Log(2._dp) + (Hm1(y)**2*Hm11(y)*Log(2._dp))/2._dp - 
     -  Hm10(y)*Hm11(y)*Log(2._dp) - (Hm11(y)**2*Log(2._dp))/2._dp + 2._dp*H1h(y)*Hm110(y)*Log(2._dp) + 
     -  2._dp*Hm1(y)*Hm111(y)*Log(2._dp) + 2._dp*Hm1(y)*Hm12(y)*Log(2._dp) - 2._dp*Hm120(y)*Log(2._dp) - 
     -  2._dp*Hm13(y)*Log(2._dp) + 2._dp*H1h(y)*Hm1m10(y)*Log(2._dp) - 2._dp*Hm1(y)*Hm1m10(y)*Log(2._dp) + 
     -  2._dp*Hm1m100(y)*Log(2._dp) + 2*H1h(y)*Hm1m11(y)*Log(2._dp) - 2._dp*Hm1(y)*Hm1m11(y)*Log(2._dp) - 
     -  2._dp*Hm1m12(y)*Log(2._dp) + 4*Hm1m1m10(y)*Log(2._dp) + 4._dp*Hm1m1m11(y)*Log(2._dp) + 
     -  2._dp*H21(y)*Ho(y)*Log(2._dp) - H1h(y)*H2h(y)*Ho(y)*Log(2._dp) + 
     -  (H1h(y)*Hm1(y)**2*Ho(y)*Log(2._dp))/2. - H1h(y)*Hm10(y)*Ho(y)*Log(2._dp) - 
     -  H1h(y)*Hm11(y)*Ho(y)*Log(2._dp) + H21(y)*Log(2._dp)**2 - 
     -  (H1h(y)*H2h(y)*Log(2._dp)**2)/2._dp + (H2h(y)*Hm1(y)*Log(2._dp)**2)/2._dp + 
     -  (H1h(y)*Hm1(y)**2*Log(2._dp)**2)/4._dp + (Hm1(y)**3*Log(2._dp)**2)/12._dp + 
     -  (H1h(y)*Hm10(y)*Log(2._dp)**2)/2._dp - (Hm1(y)*Hm10(y)*Log(2._dp)**2)/2._dp + 
     -  (H1h(y)*Hm11(y)*Log(2._dp)**2)/2._dp - (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2._dp - 
     -  Hm111(y)*Log(2._dp)**2 - Hm12(y)*Log(2._dp)**2 + Hm1m10(y)*Log(2._dp)**2 + 
     -  Hm1m11(y)*Log(2._dp)**2 - (H1h(y)*Hm1(y)*Ho(y)*Log(2._dp)**2)/2._dp + 
     -  (Pi**2*Zeta(3))/2._dp - H2h(y)*Zeta(3) - H1h(y)*Hm1(y)*Zeta(3) - 
     -  (Hm1(y)**2*Zeta(3))/2. + Hm10(y)*Zeta(3) + Hm11(y)*Zeta(3) + 
     -  H1h(y)*Ho(y)*Zeta(3) + H1h(y)*Log(2._dp)*Zeta(3) + Hm1(y)*Log(2._dp)*Zeta(3) - 
     -  (11._dp*Zeta(5))/2._dp
      
      else
      write(*,*)' x out of range HB01011.  x = ',x
      endif
      
      return
      end 


      function HB00111(x) !B3
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB00111 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB00111 = HB5(0,0,1,1,1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB00111 =         -(Pi**4*H1h(y))/90. + H1h(y)*H4(y) - HB00011(y) + HBm10001(y) + HBm10010(y) + 
     -  HBm10100(y) - H1h(y)*HBm1100(y) + HBm11001(y) + HBm11010(y) + HBm11100(y) - 
     -  HBm1m1000(y) + HBm1m1001(y) + HBm1m1010(y) - H1h(y)*HBm1m110(y) - 
     -  HBm1m1100(y) + HBm1m1101(y) + HBm1m1110(y) - 2*HBm1m1m100(y) + HBm1m1m101(y) - 
     -  2*HBm1m1m110(y) + HBm1m1m111(y) - 3*HBm1m1m1m10(y) - 3*HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/90. - H31(y)*Hm1(y) + H1h(y)*H3h(y)*Hm1(y) - 
     -  HBm1101(y)*Hm1(y) - HBm1110(y)*Hm1(y) + HBm1m110(y)*Hm1(y) - 
     -  HBm1m111(y)*Hm1(y) - (H21(y)*Hm1(y)**2)/2. + (H1h(y)*H2h(y)*Hm1(y)**2)/2. + 
     -  (H1h(y)**2*Hm1(y)**3)/12. + (H1h(y)*Hm1(y)**4)/24. + Hm1(y)**5/120. - 
     -  (H1h(y)*Hm1(y)**2*Hm10(y))/2. + H1h(y)*Hm1(y)*Hm100(y) - H1h(y)*Hm1000(y) - 
     -  (H1h(y)*Hm1(y)**2*Hm11(y))/2. + H1h(y)*Hm1(y)*Hm110(y) + 
     -  (Hm1(y)**2*Hm111(y))/2. + (Hm1(y)**2*Hm12(y))/2. - Hm1(y)*Hm120(y) - 
     -  Hm1(y)*Hm13(y) + H1h(y)*Hm1(y)*Hm1m10(y) - (Hm1(y)**2*Hm1m10(y))/2. - 
     -  H1h(y)*Hm1m100(y) + Hm1(y)*Hm1m100(y) + H1h(y)*Hm1(y)*Hm1m11(y) - 
     -  (Hm1(y)**2*Hm1m11(y))/2. - Hm1(y)*Hm1m12(y) - H1h(y)*Hm1m1m10(y) + 
     -  2*Hm1(y)*Hm1m1m10(y) - H1h(y)*Hm1m1m11(y) + 2*Hm1(y)*Hm1m1m11(y) + 
     -  H31(y)*Ho(y) - H1h(y)*H3h(y)*Ho(y) + H21(y)*Hm1(y)*Ho(y) - 
     -  H1h(y)*H2h(y)*Hm1(y)*Ho(y) - (H1h(y)**2*Hm1(y)**2*Ho(y))/4. - 
     -  (H21(y)*Ho(y)**2)/2. + (H1h(y)*H2h(y)*Ho(y)**2)/2. + 
     -  (H1h(y)**2*Hm1(y)*Ho(y)**2)/4. - (H1h(y)**2*Ho(y)**3)/12. + H31(y)*Log(2._dp) - 
     -  H1h(y)*H3h(y)*Log(2._dp) + HBm1101(y)*Log(2._dp) + HBm1110(y)*Log(2._dp) - 
     -  HBm1m110(y)*Log(2._dp) + HBm1m111(y)*Log(2._dp) + H21(y)*Hm1(y)*Log(2._dp) - 
     -  H1h(y)*H2h(y)*Hm1(y)*Log(2._dp) - (H1h(y)**2*Hm1(y)**2*Log(2._dp))/4. - 
     -  (H1h(y)*Hm1(y)**3*Log(2._dp))/6. - (Hm1(y)**4*Log(2._dp))/24. + 
     -  H1h(y)*Hm1(y)*Hm10(y)*Log(2._dp) - H1h(y)*Hm100(y)*Log(2._dp) + 
     -  H1h(y)*Hm1(y)*Hm11(y)*Log(2._dp) - H1h(y)*Hm110(y)*Log(2._dp) - 
     -  Hm1(y)*Hm111(y)*Log(2._dp) - Hm1(y)*Hm12(y)*Log(2._dp) + Hm120(y)*Log(2._dp) + 
     -  Hm13(y)*Log(2._dp) - H1h(y)*Hm1m10(y)*Log(2._dp) + Hm1(y)*Hm1m10(y)*Log(2._dp) - 
     -  Hm1m100(y)*Log(2._dp) - H1h(y)*Hm1m11(y)*Log(2._dp) + Hm1(y)*Hm1m11(y)*Log(2._dp) + 
     -  Hm1m12(y)*Log(2._dp) - 2*Hm1m1m10(y)*Log(2._dp) - 2*Hm1m1m11(y)*Log(2._dp) - 
     -  H21(y)*Ho(y)*Log(2._dp) + H1h(y)*H2h(y)*Ho(y)*Log(2._dp) + 
     -  (H1h(y)**2*Hm1(y)*Ho(y)*Log(2._dp))/2. - (H1h(y)**2*Ho(y)**2*Log(2._dp))/4. - 
     -  (H21(y)*Log(2._dp)**2)/2. + (H1h(y)*H2h(y)*Log(2._dp)**2)/2. + 
     -  (H1h(y)**2*Hm1(y)*Log(2._dp)**2)/4. + (H1h(y)*Hm1(y)**2*Log(2._dp)**2)/4. + 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. - (H1h(y)*Hm10(y)*Log(2._dp)**2)/2. - 
     -  (H1h(y)*Hm11(y)*Log(2._dp)**2)/2. + (Hm111(y)*Log(2._dp)**2)/2. + 
     -  (Hm12(y)*Log(2._dp)**2)/2. - (Hm1m10(y)*Log(2._dp)**2)/2. - (Hm1m11(y)*Log(2._dp)**2)/2. - 
     -  (H1h(y)**2*Ho(y)*Log(2._dp)**2)/4. - (H1h(y)**2*Log(2._dp)**3)/12. - 
     -  (H1h(y)*Hm1(y)*Log(2._dp)**3)/6. - (Hm1(y)**2*Log(2._dp)**3)/12. - 
     -  (Pi**2*Zeta(3))/6. + 2*Zeta(5)
      
      else
      write(*,*)' x out of range HB01011.  x = ',x
      endif
      
      return
      end 
      
      
      function HB00101(x) !B4
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB00101 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB00101 = HB5(0,0,1,0,1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB00101 =          -(Pi**4*H1h(y))/120. - (Pi**2*H21(y))/6. + (Pi**2*H1h(y)*H2h(y))/6. + 
     -  H21(y)*H2h(y) - (H1h(y)*H2h(y)**2)/2. - 2*H1h(y)*H31(y) + H1h(y)**2*H3h(y) - 
     -  HB01011(y) + 2*HBm10011(y) + 2*HBm10101(y) + 3*HBm10110(y) + HBm101m11(y) - 
     -  HBm10m101(y) + HBm10m111(y) - 2*H1h(y)*HBm1101(y) + 2*HBm11011(y) - 
     -  2*H1h(y)*HBm1110(y) + 3*HBm11110(y) + 2*HBm11111(y) - HBm11m111(y) - 
     -  4*HBm1m1001(y) - 3*HBm1m1010(y) + 4*HBm1m1011(y) - HBm1m10m10(y) - 
     -  HBm1m10m11(y) + 2*H1h(y)*HBm1m110(y) - 2*HBm1m1101(y) - 2*H1h(y)*HBm1m111(y) - 
     -  3*HBm1m1110(y) - HBm1m11m10(y) - HBm1m11m11(y) - 7*HBm1m1m101(y) - 
     -  7*HBm1m1m111(y) + 7*HBm1m1m1m10(y) + 7*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/120. + 
     -  (Pi**2*H1h(y)**2*Hm1(y))/12. - 2*H1h(y)*H21(y)*Hm1(y) + 3*H211(y)*Hm1(y) + 
     -  (H1h(y)**2*H2h(y)*Hm1(y))/2. + 3*HBm1m111(y)*Hm1(y) + 
     -  (Pi**2*H1h(y)*Hm1(y)**2)/12. + (H21(y)*Hm1(y)**2)/2. - 
     -  (H1h(y)*H2h(y)*Hm1(y)**2)/2. + (Pi**2*Hm1(y)**3)/36. - 
     -  (H1h(y)**2*Hm1(y)**3)/12. - (H1h(y)*Hm1(y)**4)/24. - Hm1(y)**5/120. - 
     -  (Pi**2*H1h(y)*Hm10(y))/6. - H21(y)*Hm10(y) + H1h(y)*H2h(y)*Hm10(y) - 
     -  (H1h(y)**2*Hm1(y)*Hm10(y))/2. + (H1h(y)*Hm1(y)**2*Hm10(y))/2. - 
     -  (H1h(y)*Hm10(y)**2)/2. + H1h(y)**2*Hm100(y) - (Pi**2*H1h(y)*Hm11(y))/6. - 
     -  H21(y)*Hm11(y) + H1h(y)*H2h(y)*Hm11(y) - (H1h(y)**2*Hm1(y)*Hm11(y))/2. + 
     -  (H1h(y)*Hm1(y)**2*Hm11(y))/2. - H1h(y)*Hm10(y)*Hm11(y) - 
     -  (H1h(y)*Hm11(y)**2)/2. + H1h(y)**2*Hm110(y) + (Pi**2*Hm111(y))/6. + 
     -  2*H1h(y)*Hm1(y)*Hm111(y) - (Hm1(y)**2*Hm111(y))/2. + Hm10(y)*Hm111(y) + 
     -  Hm11(y)*Hm111(y) - 3*Hm1(y)*Hm1111(y) + (Pi**2*Hm12(y))/6. + 
     -  2*H1h(y)*Hm1(y)*Hm12(y) - (Hm1(y)**2*Hm12(y))/2. + Hm10(y)*Hm12(y) - 
     -  2*H1h(y)*Hm120(y) - 3*Hm1(y)*Hm121(y) - 2*H1h(y)*Hm13(y) - 
     -  (Pi**2*Hm1m10(y))/6. + H1h(y)**2*Hm1m10(y) - 2*H1h(y)*Hm1(y)*Hm1m10(y) + 
     -  (Hm1(y)**2*Hm1m10(y))/2. + 2*H1h(y)*Hm1m100(y) - (Pi**2*Hm1m11(y))/6. + 
     -  H1h(y)**2*Hm1m11(y) - 2*H1h(y)*Hm1(y)*Hm1m11(y) + (Hm1(y)**2*Hm1m11(y))/2. - 
     -  2*H1h(y)*Hm1m12(y) + 3*Hm1(y)*Hm1m12(y) + 4*H1h(y)*Hm1m1m10(y) - 
     -  3*Hm1(y)*Hm1m1m10(y) + 4*H1h(y)*Hm1m1m11(y) - 3*Hm1(y)*Hm1m1m11(y) - 
     -  (Pi**2*H1h(y)**2*Ho(y))/12. + 2*H1h(y)*H21(y)*Ho(y) - 3*H211(y)*Ho(y) - 
     -  (H1h(y)**2*H2h(y)*Ho(y))/2. + (H1h(y)**2*Hm1(y)**2*Ho(y))/4. - 
     -  (H1h(y)**2*Hm10(y)*Ho(y))/2. - (H1h(y)**2*Hm11(y)*Ho(y))/2. - 
     -  (Pi**2*H1h(y)**2*Log(2._dp))/12. + 2*H1h(y)*H21(y)*Log(2._dp) - 3*H211(y)*Log(2._dp) - 
     -  (H1h(y)**2*H2h(y)*Log(2._dp))/2. - 3*HBm1m111(y)*Log(2._dp) - 
     -  (Pi**2*H1h(y)*Hm1(y)*Log(2._dp))/6. - H21(y)*Hm1(y)*Log(2._dp) + 
     -  H1h(y)*H2h(y)*Hm1(y)*Log(2._dp) - (Pi**2*Hm1(y)**2*Log(2._dp))/12. + 
     -  (H1h(y)**2*Hm1(y)**2*Log(2._dp))/4. + (H1h(y)*Hm1(y)**3*Log(2._dp))/6. + 
     -  (Hm1(y)**4*Log(2._dp))/24. + (H1h(y)**2*Hm10(y)*Log(2._dp))/2. - 
     -  H1h(y)*Hm1(y)*Hm10(y)*Log(2._dp) + (H1h(y)**2*Hm11(y)*Log(2._dp))/2. - 
     -  H1h(y)*Hm1(y)*Hm11(y)*Log(2._dp) - 2*H1h(y)*Hm111(y)*Log(2._dp) + 
     -  Hm1(y)*Hm111(y)*Log(2._dp) + 3*Hm1111(y)*Log(2._dp) - 2*H1h(y)*Hm12(y)*Log(2._dp) + 
     -  Hm1(y)*Hm12(y)*Log(2._dp) + 3*Hm121(y)*Log(2._dp) + 2*H1h(y)*Hm1m10(y)*Log(2._dp) - 
     -  Hm1(y)*Hm1m10(y)*Log(2._dp) + 2*H1h(y)*Hm1m11(y)*Log(2._dp) - 
     -  Hm1(y)*Hm1m11(y)*Log(2._dp) - 3*Hm1m12(y)*Log(2._dp) + 3*Hm1m1m10(y)*Log(2._dp) + 
     -  3*Hm1m1m11(y)*Log(2._dp) - (H1h(y)**2*Hm1(y)*Ho(y)*Log(2._dp))/2. + 
     -  (Pi**2*Zeta(3))/2. - H1h(y)**2*Zeta(3) - 2*H1h(y)*Hm1(y)*Zeta(3) - 
     -  Hm1(y)**2*Zeta(3) - (11*Zeta(5))/2.
      
      else
      write(*,*)' x out of range HB00101.  x = ',x
      endif
      
      return
      end       


      function HB00011(x) !B5 
      ! Only 5 digits precision in 
      ! (sqrt(2._dp)-1._dp)<x.and.x<1._dp !
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB00011 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB00011 = HB5(0, 0, 0, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB00011 =      -(Pi**4*H1h(y))/360._dp - (H1h(y)**2*H3h(y))/2._dp + H1h(y)*HB0011(y) - HB00111(y) + 
     -  H1h(y)*HBm1001(y) - HBm10011(y) + H1h(y)*HBm1010(y) - HBm10101(y) - 
     -  HBm10110(y) + H1h(y)*HBm1101(y) - HBm11011(y) + H1h(y)*HBm1110(y) - 
     -  HBm11110(y) - HBm11111(y) - H1h(y)*HBm1m100(y) + HBm1m1001(y) + 
     -  H1h(y)*HBm1m101(y) + HBm1m1010(y) - HBm1m1011(y) - H1h(y)*HBm1m110(y) + 
     -  HBm1m1101(y) + H1h(y)*HBm1m111(y) + HBm1m1110(y) - HBm1m1111(y) - 
     -  2._dp*H1h(y)*HBm1m1m10(y) - HBm1m1m100(y) + 2._dp*HBm1m1m101(y) - 
     -  2._dp*H1h(y)*HBm1m1m11(y) - HBm1m1m110(y) + 2._dp*HBm1m1m111(y) - 3*HBm1m1m1m10(y) - 
     -  3._dp*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/360._dp + H1h(y)*H21(y)*Hm1(y) - 
     -  (H1h(y)**2*H2h(y)*Hm1(y))/2._dp - HB0111(y)*Hm1(y) + HBm1011(y)*Hm1(y) + 
     -  HBm1111(y)*Hm1(y) - HBm1m101(y)*Hm1(y) - HBm1m111(y)*Hm1(y) + 
     -  HBm1m1m10(y)*Hm1(y) + HBm1m1m11(y)*Hm1(y) - (H1h(y)**3*Hm1(y)**2)/12._dp - 
     -  (H1h(y)**2*Hm1(y)**3)/12._dp - (H1h(y)*Hm1(y)**4)/24._dp - Hm1(y)**5/120._dp + 
     -  (H1h(y)**2*Hm1(y)*Hm10(y))/2._dp - (H1h(y)**2*Hm100(y))/2._dp + 
     -  (H1h(y)**2*Hm1(y)*Hm11(y))/2._dp - (H1h(y)**2*Hm110(y))/2._dp - 
     -  H1h(y)*Hm1(y)*Hm111(y) - H1h(y)*Hm1(y)*Hm12(y) - (H1h(y)**2*Hm1m10(y))/2._dp + 
     -  H1h(y)*Hm1(y)*Hm1m10(y) - (H1h(y)**2*Hm1m11(y))/2._dp + H1h(y)*Hm1(y)*Hm1m11(y) - 
     -  H1h(y)*H21(y)*Ho(y) + (H1h(y)**2*H2h(y)*Ho(y))/2._dp + HB0111(y)*Ho(y) + 
     -  (H1h(y)**3*Hm1(y)*Ho(y))/6._dp - (H1h(y)**3*Ho(y)**2)/12._dp - 
     -  H1h(y)*H21(y)*Log(2._dp) + (H1h(y)**2*H2h(y)*Log(2._dp))/2._dp + HB0111(y)*Log(2._dp) - 
     -  HBm1011(y)*Log(2._dp) - HBm1111(y)*Log(2._dp) + HBm1m101(y)*Log(2._dp) + 
     -  HBm1m111(y)*Log(2._dp) - HBm1m1m10(y)*Log(2._dp) - HBm1m1m11(y)*Log(2._dp) + 
     -  (H1h(y)**3*Hm1(y)*Log(2._dp))/6._dp + (H1h(y)**2*Hm1(y)**2*Log(2._dp))/4._dp + 
     -  (H1h(y)*Hm1(y)**3*Log(2._dp))/6._dp + (Hm1(y)**4*Log(2._dp))/24._dp - 
     -  (H1h(y)**2*Hm10(y)*Log(2._dp))/2._dp - (H1h(y)**2*Hm11(y)*Log(2._dp))/2. + 
     -  H1h(y)*Hm111(y)*Log(2._dp) + H1h(y)*Hm12(y)*Log(2._dp) - H1h(y)*Hm1m10(y)*Log(2._dp) - 
     -  H1h(y)*Hm1m11(y)*Log(2._dp) - (H1h(y)**3*Ho(y)*Log(2._dp))/6._dp - 
     -  (H1h(y)**3*Log(2._dp)**2)/12._dp - (H1h(y)**2*Hm1(y)*Log(2._dp)**2)/4._dp - 
     -  (H1h(y)*Hm1(y)**2*Log(2._dp)**2)/4._dp - (Hm1(y)**3*Log(2._dp)**2)/12._dp - 
     -  (Pi**2*Zeta(3))/6._dp + (H1h(y)**2*Zeta(3))/2._dp + H1h(y)*Hm1(y)*Zeta(3) + 
     -  (Hm1(y)**2*Zeta(3))/2._dp + 2._dp*Zeta(5)
      
      else
      write(*,*)' x out of range HB01011.  x = ',x
      endif
      
      return
      end       


      function HB00001(x) !B6
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HB00001 = zip
      li4half = 0.5174790616738993_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HB00001 = HB5(0, 0, 0, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HB00001 = -(Pi**4*H1h(y))/90. - (Pi**2*H1h(y)**3)/36. - (H1h(y)**2*H21(y))/2. + 
     -  H1h(y)*H211(y) + (H1h(y)**3*H2h(y))/6. - HB01111(y) + HBm10111(y) + 
     -  HBm11111(y) - HBm1m1011(y) + H1h(y)*HBm1m111(y) - HBm1m1111(y) + 
     -  HBm1m1m101(y) + HBm1m1m111(y) - HBm1m1m1m10(y) - HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/90. - (Pi**2*H1h(y)**2*Hm1(y))/12. + (H1h(y)**4*Hm1(y))/24. - 
     -  (Pi**2*H1h(y)*Hm1(y)**2)/12. + (H1h(y)**3*Hm1(y)**2)/12. - 
     -  (Pi**2*Hm1(y)**3)/36. + (H1h(y)**2*Hm1(y)**3)/12. + (H1h(y)*Hm1(y)**4)/24. + 
     -  Hm1(y)**5/120. - (H1h(y)**3*Hm10(y))/6. - (H1h(y)**3*Hm11(y))/6. + 
     -  (H1h(y)**2*Hm111(y))/2. - H1h(y)*Hm1111(y) + (H1h(y)**2*Hm12(y))/2. - 
     -  H1h(y)*Hm121(y) - (H1h(y)**2*Hm1m10(y))/2. - (H1h(y)**2*Hm1m11(y))/2. + 
     -  H1h(y)*Hm1m12(y) - H1h(y)*Hm1m1m10(y) - H1h(y)*Hm1m1m11(y) - 
     -  (H1h(y)**4*Ho(y))/24. - (H1h(y)**4*Log(2._dp))/24. - 
     -  (H1h(y)**3*Hm1(y)*Log(2._dp))/6. - (H1h(y)**2*Hm1(y)**2*Log(2._dp))/4. - 
     -  (H1h(y)*Hm1(y)**3*Log(2._dp))/6. - (Hm1(y)**4*Log(2._dp))/24. + 
     -  (H1h(y)**2*Zeta(3))/2. + H1h(y)*Hm1(y)*Zeta(3) + (Hm1(y)**2*Zeta(3))/2. + 
     -  Zeta(5)
      
      else
      write(*,*)' x out of range HB00001.  x = ',x
      endif
      
      return
      end       


      function HBm11111(x) !B7
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11111 = HB5(-1, 1, 1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11111 = li5half - HBm10000(y) - HBm1m1000(y) - HBm1m1m100(y) - HBm1m1m1m10(y) - 
     -  Hm1(y)**5/120. + (Hm1(y)**3*Hm10(y))/6. - (Hm1(y)**2*Hm100(y))/2. + 
     -  Hm1(y)*Hm1000(y) - (Hm1(y)**2*Hm1m10(y))/2. + Hm1(y)*Hm1m100(y) + 
     -  Hm1(y)*Hm1m1m10(y) + (Hm1(y)**4*Log(2._dp))/24. - (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. + 
     -  Hm1(y)*Hm100(y)*Log(2._dp) - Hm1000(y)*Log(2._dp) + Hm1(y)*Hm1m10(y)*Log(2._dp) - 
     -  Hm1m100(y)*Log(2._dp) - Hm1m1m10(y)*Log(2._dp) - (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1(y)*Hm10(y)*Log(2._dp)**2)/2. - (Hm100(y)*Log(2._dp)**2)/2. - 
     -  (Hm1m10(y)*Log(2._dp)**2)/2. + (Hm1(y)**2*Log(2._dp)**3)/12. - 
     -  (Hm10(y)*Log(2._dp)**3)/6. - (Hm1(y)*Log(2._dp)**4)/24.
      
      
      
      else
      write(*,*)' x out of range HBm11111.  x = ',x
      endif
      
      return
      end         



      function HBm11110(x) !B8
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11110 = HB5(-1, 1, 1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11110 = -2*li5half - HBm10001(y) + HBm100m11(y) - 2*HBm10m100(y) + HBm10m101(y) - 
     -  4*HBm1m1000(y) + HBm1m1001(y) + 2*HBm1m10m10(y) + HBm1m10m11(y) + 
     -  HBm1m11m10(y) + 6*HBm1m1m100(y) + 2*HBm1m1m101(y) + 3*HBm1m1m110(y) + 
     -  2*HBm1m1m1m10(y) + HBm1m1m1m11(y) + (Pi**4*Hm1(y))/90. + 
     -  (Pi**2*Hm1(y)**3)/36. + Hm1(y)**5/120. - (Pi**2*Hm1(y)*Hm10(y))/6. - 
     -  (Hm1(y)**3*Hm10(y))/6. + (Pi**2*Hm100(y))/6. + (Hm1(y)**2*Hm100(y))/2. + 
     -  Hm10(y)*Hm100(y) - Hm1(y)*Hm1000(y) + (Pi**2*Hm1m10(y))/6. + 
     -  (Hm1(y)**2*Hm1m10(y))/2. - Hm10(y)*Hm1m10(y) - Hm1(y)*Hm1m100(y) - 
     -  Hm10(y)*Hm1m11(y) - Hm1(y)*Hm1m1m10(y) - li4half*Log(2._dp) + 
     -  (Pi**4*Log(2._dp))/720. - (Pi**2*Hm1(y)**2*Log(2._dp))/12. + 
     -  (Pi**2*Hm10(y)*Log(2._dp))/6. + (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + 
     -  (Pi**2*Log(2._dp)**3)/36. - Log(2._dp)**5/40. + (Pi**2*Zeta(3))/12. - 
     -  (Hm1(y)**2*Zeta(3))/2. + Hm10(y)*Zeta(3) + Hm1(y)*Log(2._dp)*Zeta(3) - 
     -  (Log(2._dp)**2*Zeta(3))/2. - Zeta(5)/32.
      
      
      
      
      else
      write(*,*)' x out of range HBm11110.  x = ',x
      endif
      
      return
      end  
      
      
      
      function HBm11101(x) !B9
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11101 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11101 = HB5(-1, 1, 1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11101 =  2*li5half - HBm10010(y) - HBm100m11(y) + 3*HBm10m100(y) - HBm10m101(y) + 
     -  HBm10m110(y) + 6*HBm1m1000(y) - 2*HBm1m1001(y) + HBm1m1010(y) - 
     -  3*HBm1m10m10(y) - HBm1m10m11(y) - 2*HBm1m11m10(y) - 9*HBm1m1m100(y) - 
     -  3*HBm1m1m101(y) - 7*HBm1m1m110(y) - 3*HBm1m1m1m10(y) - 4*HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/30. - HBm10m11(y)*Hm1(y) - (Pi**2*Hm1(y)**3)/36. + 
     -  Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm10(y))/6. - (Hm1(y)**3*Hm10(y))/6. - 
     -  (Hm1(y)*Hm10(y)**2)/2. - (Pi**2*Hm100(y))/6. + (Hm1(y)**2*Hm100(y))/2. - 
     -  Hm10(y)*Hm100(y) + Hm1(y)*Hm13(y) - (Pi**2*Hm1m10(y))/6. + 
     -  (Hm1(y)**2*Hm1m10(y))/2. + 2*Hm10(y)*Hm1m10(y) + 2*Hm10(y)*Hm1m11(y) - 
     -  Hm1(y)*Hm1m12(y) + Hm1(y)*Hm1m1m11(y) + 3*li4half*Log(2._dp) - 
     -  (19*Pi**4*Log(2._dp))/1440. + HBm10m11(y)*Log(2._dp) + (Pi**2*Hm1(y)**2*Log(2._dp))/12. - 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Pi**2*Hm10(y)*Log(2._dp))/6. + 
     -  (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. + (Hm10(y)**2*Log(2._dp))/2. - 
     -  Hm1(y)*Hm100(y)*Log(2._dp) - Hm13(y)*Log(2._dp) - Hm1(y)*Hm1m10(y)*Log(2._dp) + 
     -  Hm1m12(y)*Log(2._dp) - Hm1m1m11(y)*Log(2._dp) - (Pi**2*Hm1(y)*Log(2._dp)**2)/12. - 
     -  (5*Pi**2*Log(2._dp)**3)/72. + (13*Log(2._dp)**5)/120. - (3*Pi**2*Zeta(3))/32. + 
     -  Hm1(y)**2*Zeta(3) - 2*Hm10(y)*Zeta(3) - 2*Hm1(y)*Log(2._dp)*Zeta(3) + 
     -  (23*Log(2._dp)**2*Zeta(3))/16. - (23*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm11101.  x = ',x
      endif
      
      return
      end  

      function HBm11100(x) !B10
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11100 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11100 = HB5(-1, 1, 1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11100 = -2*li5half - HBm10011(y) + HBm10m101(y) + HBm10m111(y) + 2*HBm1m1001(y) + 
     -  HBm1m1011(y) + HBm1m10m10(y) + HBm1m11m10(y) + 3*HBm1m1m100(y) + 
     -  3*HBm1m1m110(y) - HBm1m1m111(y) + 2*HBm1m1m1m10(y) + 3*HBm1m1m1m11(y) + 
     -  (Pi**4*Hm1(y))/360. + HBm10m11(y)*Hm1(y) - Hm1(y)**5/120. + 
     -  (Hm1(y)**3*Hm10(y))/6. + (Hm1(y)*Hm10(y)**2)/2. - (Hm1(y)**2*Hm100(y))/2. - 
     -  Hm1(y)*Hm13(y) - (Hm1(y)**2*Hm1m10(y))/2. - Hm10(y)*Hm1m10(y) - 
     -  Hm10(y)*Hm1m11(y) + Hm1(y)*Hm1m12(y) - Hm1(y)*Hm1m1m11(y) - 2*li4half*Log(2._dp) - 
     -  (19*Pi**4*Log(2._dp))/1440. + (Pi**2*Log(2._dp)**3)/18. - Log(2._dp)**5/15. + 
     -  (7*Pi**2*Zeta(3))/96. - (Hm1(y)**2*Zeta(3))/2. + Hm10(y)*Zeta(3) + 
     -  Hm1(y)*Log(2._dp)*Zeta(3) - (Log(2._dp)**2*Zeta(3))/2. + (151*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm11100.  x = ',x
      endif
      
      return
      end  
      
      
      function HBm11011(x) !B11
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11011 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11011 = HB5(-1, 1, 0, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11011 = -4*li5half - HBm10100(y) - HBm10m100(y) - HBm10m110(y) - 2*HBm1m1010(y) + 
     -  HBm1m10m10(y) + HBm1m1100(y) + HBm1m11m10(y) + 7*HBm1m1m100(y) + 
     -  6*HBm1m1m110(y) + 7*HBm1m1m1m10(y) + 6*HBm1m1m1m11(y) + (Pi**4*Hm1(y))/30. + 
     -  HBm10m11(y)*Hm1(y) - HBm1m110(y)*Hm1(y) + Hm1(y)**5/120. - 
     -  (Hm1(y)**3*Hm10(y))/6. + (Hm1(y)*Hm10(y)**2)/2. - (Hm1(y)**2*Hm12(y))/2. + 
     -  Hm1(y)*Hm120(y) + Hm1(y)**2*Hm1m10(y) - Hm10(y)*Hm1m10(y) - 
     -  2*Hm1(y)*Hm1m100(y) + (Hm1(y)**2*Hm1m11(y))/2. - Hm10(y)*Hm1m11(y) + 
     -  2*Hm1(y)*Hm1m12(y) - 4*Hm1(y)*Hm1m1m10(y) - 3*Hm1(y)*Hm1m1m11(y) - 
     -  3*li4half*Log(2._dp) - (Pi**4*Log(2._dp))/288. - HBm10m11(y)*Log(2._dp) + 
     -  HBm1m110(y)*Log(2._dp) - (Hm1(y)**4*Log(2._dp))/24. + (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. - 
     -  (Hm10(y)**2*Log(2._dp))/2. + Hm1(y)*Hm12(y)*Log(2._dp) - Hm120(y)*Log(2._dp) - 
     -  2*Hm1(y)*Hm1m10(y)*Log(2._dp) + 2*Hm1m100(y)*Log(2._dp) - Hm1(y)*Hm1m11(y)*Log(2._dp) - 
     -  2*Hm1m12(y)*Log(2._dp) + 4*Hm1m1m10(y)*Log(2._dp) + 3*Hm1m1m11(y)*Log(2._dp) + 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. - (Hm1(y)*Hm10(y)*Log(2._dp)**2)/2. - 
     -  (Hm12(y)*Log(2._dp)**2)/2. + Hm1m10(y)*Log(2._dp)**2 + (Hm1m11(y)*Log(2._dp)**2)/2. + 
     -  (5*Pi**2*Log(2._dp)**3)/72. - (11*Log(2._dp)**5)/120. + (11*Pi**2*Zeta(3))/48. - 
     -  (Hm1(y)**2*Zeta(3))/2. + Hm10(y)*Zeta(3) + Hm1(y)*Log(2._dp)*Zeta(3) - 
     -  (11*Log(2._dp)**2*Zeta(3))/8. + (81*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm11011.  x = ',x
      endif
      
      return
      end  

      function HBm11010(x) !B12
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11010 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11010 = HB5(-1, 1, 0, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11010 = 8*li5half - HBm10101(y) + HBm101m11(y) - 3*HBm10m101(y) - 4*HBm1m1001(y) - 
     -  4*HBm1m10m10(y) - 2*HBm1m10m11(y) + HBm1m1101(y) - 3*HBm1m11m10(y) - 
     -  HBm1m11m11(y) - 12*HBm1m1m100(y) - 2*HBm1m1m101(y) - 9*HBm1m1m110(y) - 
     -  8*HBm1m1m1m10(y) - 7*HBm1m1m1m11(y) - (7*Pi**4*Hm1(y))/360. - 
     -  HBm10m11(y)*Hm1(y) + HBm1m110(y)*Hm1(y) - (Pi**2*Hm1(y)**3)/36. - 
     -  Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm10(y))/6. + (Hm1(y)**3*Hm10(y))/6. - 
     -  (Hm1(y)*Hm10(y)**2)/2. + (Pi**2*Hm12(y))/6. + (Hm1(y)**2*Hm12(y))/2. + 
     -  Hm10(y)*Hm12(y) - Hm1(y)*Hm120(y) - (Pi**2*Hm1m10(y))/3. - 
     -  Hm1(y)**2*Hm1m10(y) + 2*Hm10(y)*Hm1m10(y) + 2*Hm1(y)*Hm1m100(y) - 
     -  (Pi**2*Hm1m11(y))/6. - (Hm1(y)**2*Hm1m11(y))/2. + 2*Hm10(y)*Hm1m11(y) - 
     -  2*Hm1(y)*Hm1m12(y) + 4*Hm1(y)*Hm1m1m10(y) + 3*Hm1(y)*Hm1m1m11(y) + 
     -  4*li4half*Log(2._dp) + (17*Pi**4*Log(2._dp))/480. - (Pi**2*Log(2._dp)**3)/18. + 
     -  Log(2._dp)**5/10. - (7*Pi**2*Zeta(3))/48. + Hm1(y)**2*Zeta(3) - 
     -  2*Hm10(y)*Zeta(3) - 2*Hm1(y)*Log(2._dp)*Zeta(3) + Log(2._dp)**2*Zeta(3) - 
     -  (227*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm11010.  x = ',x
      endif
      
      return
      end  
      
      
      function HBm11001(x) 
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11001 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11001 = HB5(-1, 1, 0, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11001 = -2*li5half - HBm10110(y) - HBm101m11(y) + 2*HBm10m101(y) - HBm10m111(y) + 
     -  4*HBm1m1001(y) + 2*HBm1m1010(y) - 2*HBm1m1011(y) + 3*HBm1m10m10(y) + 
     -  2*HBm1m10m11(y) + HBm1m1110(y) + 2*HBm1m11m10(y) + HBm1m11m11(y) + 
     -  6*HBm1m1m100(y) + 6*HBm1m1m101(y) + 4*HBm1m1m110(y) + 3*HBm1m1m111(y) - 
     -  3*HBm1m1m1m10(y) - 2*HBm1m1m1m11(y) + (Pi**4*Hm1(y))/72. - 
     -  HBm1m111(y)*Hm1(y) + (Pi**2*Hm1(y)**3)/36. - Hm1(y)**5/120. - 
     -  (Pi**2*Hm1(y)*Hm10(y))/6. + (Hm1(y)**3*Hm10(y))/6. - (Pi**2*Hm12(y))/6. + 
     -  (Hm1(y)**2*Hm12(y))/2. - Hm10(y)*Hm12(y) + Hm1(y)*Hm121(y) + 
     -  (Pi**2*Hm1m10(y))/3. - Hm1(y)**2*Hm1m10(y) - Hm10(y)*Hm1m10(y) + 
     -  (Pi**2*Hm1m11(y))/6. - (Hm1(y)**2*Hm1m11(y))/2. - Hm10(y)*Hm1m11(y) - 
     -  2*Hm1(y)*Hm1m12(y) + 3*Hm1(y)*Hm1m1m10(y) + 2*Hm1(y)*Hm1m1m11(y) - 
     -  (Pi**4*Log(2._dp))/60. + HBm1m111(y)*Log(2._dp) + (Hm1(y)**4*Log(2._dp))/24. - 
     -  (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. - Hm1(y)*Hm12(y)*Log(2._dp) - Hm121(y)*Log(2._dp) + 
     -  2*Hm1(y)*Hm1m10(y)*Log(2._dp) + Hm1(y)*Hm1m11(y)*Log(2._dp) + 2*Hm1m12(y)*Log(2._dp) - 
     -  3*Hm1m1m10(y)*Log(2._dp) - 2*Hm1m1m11(y)*Log(2._dp) - (Pi**2*Log(2._dp)**3)/36. + 
     -  Log(2._dp)**5/60. - (11*Pi**2*Zeta(3))/48. - (Hm1(y)**2*Zeta(3))/2. + 
     -  Hm10(y)*Zeta(3) + Hm1(y)*Log(2._dp)*Zeta(3) + (3*Log(2._dp)**2*Zeta(3))/8. + 
     -  (311*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm11001.  x = ',x
      endif
      
      return
      end  
      
      
      function HBm11000(x) !B14
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11000 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11000 = HB5(-1, 1, 0, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11000 = -HBm10111(y) + 2*HBm1m1011(y) + HBm1m1111(y) - 3*HBm1m1m101(y) - 
     -  2*HBm1m1m111(y) + 4*HBm1m1m1m10(y) + 3*HBm1m1m1m11(y) + (Pi**4*Hm1(y))/90. + 
     -  HBm1m111(y)*Hm1(y) + Hm1(y)**5/120. - (Hm1(y)**3*Hm10(y))/6. - 
     -  (Hm1(y)**2*Hm12(y))/2. - Hm1(y)*Hm121(y) + Hm1(y)**2*Hm1m10(y) + 
     -  (Hm1(y)**2*Hm1m11(y))/2. + 2*Hm1(y)*Hm1m12(y) - 3*Hm1(y)*Hm1m1m10(y) - 
     -  2*Hm1(y)*Hm1m1m11(y) + (7*Pi**4*Log(2._dp))/720. + (Pi**2*Zeta(3))/16. - 2*Zeta(5)
      
      else
      write(*,*)' x out of range HBm11000.  x = ',x
      endif
      
      return
      end              

      
      function HBm11m111(x) !B15
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11m111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11m111 = HB5(-1, 1, -1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11m111 = -3*li5half - HBm10m100(y) + HBm1m10m10(y) + 7*HBm1m1m100(y) + 
     -  7*HBm1m1m1m10(y) + 3*li4half*Hm1(y) + Hm1(y)**5/120. - 
     -  (Hm1(y)**3*Hm10(y))/6. + (Hm1(y)*Hm10(y)**2)/2. + Hm1(y)**2*Hm1m10(y) - 
     -  Hm10(y)*Hm1m10(y) - 2*Hm1(y)*Hm1m100(y) - 4*Hm1(y)*Hm1m1m10(y) - 
     -  3*li4half*Log(2._dp) - (Pi**4*Log(2._dp))/1440. + (Pi**2*Hm1(y)**2*Log(2._dp))/24. - 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Pi**2*Hm10(y)*Log(2._dp))/12. + 
     -  (Hm1(y)**2*Hm10(y)*Log(2._dp))/2. - (Hm10(y)**2*Log(2._dp))/2. - 
     -  2*Hm1(y)*Hm1m10(y)*Log(2._dp) + 2*Hm1m100(y)*Log(2._dp) + 4*Hm1m1m10(y)*Log(2._dp) - 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + (Hm1(y)**3*Log(2._dp)**2)/12. - 
     -  (Hm1(y)*Hm10(y)*Log(2._dp)**2)/2. + Hm1m10(y)*Log(2._dp)**2 + 
     -  (7*Pi**2*Log(2._dp)**3)/72. - (Hm1(y)**2*Log(2._dp)**3)/12. + (Hm10(y)*Log(2._dp)**3)/6. + 
     -  (Hm1(y)*Log(2._dp)**4)/6. - (13*Log(2._dp)**5)/120. + (23*Pi**2*Zeta(3))/96. - 
     -  (7*Hm1(y)**2*Zeta(3))/16. + (7*Hm10(y)*Zeta(3))/8. + 
     -  (7*Hm1(y)*Log(2._dp)*Zeta(3))/8. - (23*Log(2._dp)**2*Zeta(3))/16. + (23*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm11m111.  x = ',x
      endif
      
      return
      end              

      
      function HBm11m110(x) !B16
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm11m110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm11m110 = HB5(-1, 1, -1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm11m110 = -HBm10m101(y) - 4*HBm1m10m10(y) - 2*HBm1m10m11(y) - HBm1m11m10(y) - 
     -  12*HBm1m1m100(y) - 2*HBm1m1m101(y) - 3*HBm1m1m110(y) - 8*HBm1m1m1m10(y) - 
     -  HBm1m1m1m11(y) - 3*li4half*Hm1(y) + (Pi**4*Hm1(y))/96. - 
     -  (Pi**2*Hm1(y)**3)/36. - Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm10(y))/6. + 
     -  (Hm1(y)**3*Hm10(y))/6. - (Hm1(y)*Hm10(y)**2)/2. - (Pi**2*Hm1m10(y))/3. - 
     -  Hm1(y)**2*Hm1m10(y) + 2*Hm10(y)*Hm1m10(y) + 2*Hm1(y)*Hm1m100(y) + 
     -  Hm10(y)*Hm1m11(y) + 4*Hm1(y)*Hm1m1m10(y) - (Pi**4*Log(2._dp))/360. - 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Pi**2*Hm10(y)*Log(2._dp))/12. + 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/24. - (Pi**2*Log(2._dp)**3)/72. - (Hm1(y)*Log(2._dp)**4)/8. - 
     -  (5*Pi**2*Zeta(3))/48. + (Hm1(y)**2*Zeta(3))/2. - Hm10(y)*Zeta(3) - 
     -  Hm1(y)*Log(2._dp)*Zeta(3) + (Log(2._dp)**2*Zeta(3))/2. + Zeta(5)
      
      else
      write(*,*)' x out of range HBm11m110.  x = ',x
      endif
      
      return
      end  


      function HBm10111(x) 
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10111 = HB5(-1, 0, 1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10111 = li5half - HBm11000(y) - HBm1m1000(y) - 2*HBm1m1100(y) - 2*HBm1m1m100(y) - 
     -  3*HBm1m1m110(y) - 3*HBm1m1m1m10(y) - 4*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/90. + 
     -  HBm1100(y)*Hm1(y) + 2*HBm1m110(y)*Hm1(y) + Hm1(y)**5/120. + 
     -  (Hm1(y)**3*Hm11(y))/6. - (Hm1(y)**2*Hm110(y))/2. - (Hm1(y)**2*Hm1m10(y))/2. + 
     -  Hm1(y)*Hm1m100(y) - Hm1(y)**2*Hm1m11(y) + 2*Hm1(y)*Hm1m1m10(y) + 
     -  3*Hm1(y)*Hm1m1m11(y) + li4half*Log(2._dp) + (Pi**4*Log(2._dp))/90. - 
     -  HBm1100(y)*Log(2._dp) - 2*HBm1m110(y)*Log(2._dp) - (Hm1(y)**4*Log(2._dp))/24. - 
     -  (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. + Hm1(y)*Hm110(y)*Log(2._dp) + 
     -  Hm1(y)*Hm1m10(y)*Log(2._dp) - Hm1m100(y)*Log(2._dp) + 2*Hm1(y)*Hm1m11(y)*Log(2._dp) - 
     -  2*Hm1m1m10(y)*Log(2._dp) - 3*Hm1m1m11(y)*Log(2._dp) + (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. - (Hm110(y)*Log(2._dp)**2)/2. - 
     -  (Hm1m10(y)*Log(2._dp)**2)/2. - Hm1m11(y)*Log(2._dp)**2 - (Pi**2*Log(2._dp)**3)/36. - 
     -  (Hm1(y)**2*Log(2._dp)**3)/12. - (Hm11(y)*Log(2._dp)**3)/6. + Log(2._dp)**5/30. - 
     -  (7*Pi**2*Zeta(3))/96. + (7*Log(2._dp)**2*Zeta(3))/16. - (27*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm11m110.  x = ',x
      endif
      
      return
      end  


      function HBm10110(x) !B18
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10110 = HB5(-1, 0, 1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10110 =        HBm100m11(y) + HBm10m101(y) - HBm11001(y) - 2*HBm11m110(y) + HBm1m1001(y) + 
     -  HBm1m10m10(y) + 2*HBm1m10m11(y) - 2*HBm1m1101(y) - 4*HBm1m1110(y) + 
     -  2*HBm1m11m10(y) + 3*HBm1m11m11(y) + 3*HBm1m1m100(y) + 4*HBm1m1m101(y) + 
     -  6*HBm1m1m110(y) + 6*HBm1m1m111(y) + 2*HBm1m1m1m10(y) + 3*HBm1m1m1m11(y) + 
     -  (Pi**4*Hm1(y))/72. - HBm1100(y)*Hm1(y) - 2*HBm1m110(y)*Hm1(y) - 
     -  (Pi**2*Hm1(y)**3)/36. - Hm1(y)**5/120. - (Pi**2*Hm1(y)*Hm11(y))/6. - 
     -  (Hm1(y)**3*Hm11(y))/6. - Hm100(y)*Hm11(y) + (Pi**2*Hm110(y))/6. + 
     -  (Hm1(y)**2*Hm110(y))/2. + Hm10(y)*Hm110(y) + Hm11(y)*Hm110(y) + 
     -  (Pi**2*Hm1m10(y))/6. + (Hm1(y)**2*Hm1m10(y))/2. - Hm11(y)*Hm1m10(y) - 
     -  Hm1(y)*Hm1m100(y) + (Pi**2*Hm1m11(y))/3. + Hm1(y)**2*Hm1m11(y) - 
     -  Hm11(y)*Hm1m11(y) - 2*Hm1(y)*Hm1m1m10(y) - 3*Hm1(y)*Hm1m1m11(y) - 
     -  (Pi**4*Log(2._dp))/72. + (Pi**2*Hm1(y)**2*Log(2._dp))/12. + 
     -  (Pi**2*Hm11(y)*Log(2._dp))/6. - (Pi**2*Zeta(3))/96. + (Hm1(y)**2*Zeta(3))/2. + 
     -  Hm11(y)*Zeta(3) + (53*Zeta(5))/64.
     
      else
      write(*,*)' x out of range HBm10110.  x = ',x
      endif
      
      return
      end
      
      
      function HBm10101(x) !B19
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10101 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10101 = HB5(-1, 0, 1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10101 = -4*li5half - 2*HBm100m11(y) - 2*HBm10m101(y) - HBm10m110(y) - HBm11010(y) + 
     -  3*HBm11m110(y) - 4*HBm1m1001(y) - 3*HBm1m1010(y) - HBm1m10m10(y) - 
     -  3*HBm1m10m11(y) + 4*HBm1m1110(y) - 2*HBm1m11m10(y) - 4*HBm1m11m11(y) - 
     -  9*HBm1m1m101(y) - 2*HBm1m1m110(y) - 12*HBm1m1m111(y) + 7*HBm1m1m1m10(y) + 
     -  8*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/120. + HBm10m11(y)*Hm1(y) + 
     -  HBm1101(y)*Hm1(y) + 2*HBm1m111(y)*Hm1(y) + (Pi**2*Hm1(y)**3)/36. - 
     -  Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm11(y))/6. - (Hm1(y)**3*Hm11(y))/6. - 
     -  Hm1(y)*Hm10(y)*Hm11(y) + 2*Hm100(y)*Hm11(y) - (Hm1(y)*Hm11(y)**2)/2. - 
     -  (Pi**2*Hm110(y))/6. + (Hm1(y)**2*Hm110(y))/2. - Hm10(y)*Hm110(y) - 
     -  Hm11(y)*Hm110(y) - (Pi**2*Hm1m10(y))/6. + (Hm1(y)**2*Hm1m10(y))/2. + 
     -  2*Hm11(y)*Hm1m10(y) - (Pi**2*Hm1m11(y))/3. + Hm1(y)**2*Hm1m11(y) + 
     -  2*Hm11(y)*Hm1m11(y) + 3*Hm1(y)*Hm1m12(y) - 3*Hm1(y)*Hm1m1m10(y) - 
     -  4*Hm1(y)*Hm1m1m11(y) - 4*li4half*Log(2._dp) + (Pi**4*Log(2._dp))/120. - 
     -  HBm10m11(y)*Log(2._dp) - HBm1101(y)*Log(2._dp) - 2*HBm1m111(y)*Log(2._dp) - 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/12. + (Hm1(y)**4*Log(2._dp))/24. - 
     -  (Pi**2*Hm11(y)*Log(2._dp))/6. + (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. + 
     -  Hm10(y)*Hm11(y)*Log(2._dp) + (Hm11(y)**2*Log(2._dp))/2. - Hm1(y)*Hm110(y)*Log(2._dp) - 
     -  Hm1(y)*Hm1m10(y)*Log(2._dp) - 2*Hm1(y)*Hm1m11(y)*Log(2._dp) - 3*Hm1m12(y)*Log(2._dp) + 
     -  3*Hm1m1m10(y)*Log(2._dp) + 4*Hm1m1m11(y)*Log(2._dp) + (Pi**2*Log(2._dp)**3)/9. - 
     -  (2*Log(2._dp)**5)/15. + (3*Pi**2*Zeta(3))/16. - Hm1(y)**2*Zeta(3) - 
     -  2*Hm11(y)*Zeta(3) - (7*Log(2._dp)**2*Zeta(3))/4. + (89*Zeta(5))/64.
     
      else
      write(*,*)' x out of range HBm10101.  x = ',x
      endif
      
      return
      end      


      function HBm10100(x) !B20
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10100 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10100 = HB5(-1, 0, 1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10100 = -HBm101m11(y) - 2*HBm10m111(y) - HBm11011(y) + HBm11m111(y) - 5*HBm1m1011(y) + 
     -  HBm1m10m11(y) + HBm1m11m11(y) + 6*HBm1m1m101(y) + 7*HBm1m1m111(y) - 
     -  6*HBm1m1m1m10(y) - 7*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/30. - 
     -  HBm10m11(y)*Hm1(y) - HBm1101(y)*Hm1(y) - 2*HBm1m111(y)*Hm1(y) + 
     -  Hm1(y)**5/120. + (Hm1(y)**3*Hm11(y))/6. + Hm1(y)*Hm10(y)*Hm11(y) + 
     -  (Hm1(y)*Hm11(y)**2)/2. - (Hm1(y)**2*Hm110(y))/2. + Hm11(y)*Hm12(y) - 
     -  (Hm1(y)**2*Hm1m10(y))/2. - Hm11(y)*Hm1m10(y) - Hm1(y)**2*Hm1m11(y) - 
     -  Hm11(y)*Hm1m11(y) - 3*Hm1(y)*Hm1m12(y) + 3*Hm1(y)*Hm1m1m10(y) + 
     -  4*Hm1(y)*Hm1m1m11(y) + (Pi**4*Log(2._dp))/30. - (Pi**2*Zeta(3))/8. + 
     -  (Hm1(y)**2*Zeta(3))/2. + Hm11(y)*Zeta(3) + (21*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10100.  x = ',x
      endif
      
      return
      end      


      function HBm101m11(x) !B21
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm101m11 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm101m11 = HB5(-1, 0, 1, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm101m11 = 11*li5half - 2*HBm100m11(y) - 2*HBm10m101(y) - HBm10m110(y) - 4*HBm1m1001(y) - 
     -  2*HBm1m1010(y) - HBm1m10m10(y) - 2*HBm1m10m11(y) - 2*HBm1m11m10(y) - 
     -  6*HBm1m1m101(y) - 3*HBm1m1m110(y) + 7*HBm1m1m1m10(y) + 4*HBm1m1m1m11(y) + 
     -  3*li4half*Hm1(y) - (7*Pi**4*Hm1(y))/288. + HBm10m11(y)*Hm1(y) + 
     -  (Pi**2*Hm1(y)**3)/72. - Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm11(y))/12. - 
     -  (Hm1(y)**3*Hm11(y))/6. - Hm1(y)*Hm10(y)*Hm11(y) + 2*Hm100(y)*Hm11(y) - 
     -  (Pi**2*Hm110(y))/12. + (Hm1(y)**2*Hm110(y))/2. - Hm10(y)*Hm110(y) - 
     -  (Pi**2*Hm1m10(y))/12. + (Hm1(y)**2*Hm1m10(y))/2. + 2*Hm11(y)*Hm1m10(y) - 
     -  (Pi**2*Hm1m11(y))/6. + Hm1(y)**2*Hm1m11(y) + 2*Hm1(y)*Hm1m12(y) - 
     -  3*Hm1(y)*Hm1m1m10(y) - 3*Hm1(y)*Hm1m1m11(y) + (47*Pi**4*Log(2._dp))/480. - 
     -  HBm10m11(y)*Log(2._dp) + (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Hm1(y)**4*Log(2._dp))/24. + 
     -  (Pi**2*Hm11(y)*Log(2._dp))/12. + (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. + 
     -  Hm10(y)*Hm11(y)*Log(2._dp) - Hm1(y)*Hm110(y)*Log(2._dp) - Hm1(y)*Hm1m10(y)*Log(2._dp) - 
     -  2*Hm1(y)*Hm1m11(y)*Log(2._dp) - 2*Hm1m12(y)*Log(2._dp) + 3*Hm1m1m10(y)*Log(2._dp) + 
     -  3*Hm1m1m11(y)*Log(2._dp) + (Pi**2*Hm1(y)*Log(2._dp)**2)/8. - 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. - (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. + 
     -  (Hm110(y)*Log(2._dp)**2)/2. + (Hm1m10(y)*Log(2._dp)**2)/2. + Hm1m11(y)*Log(2._dp)**2 - 
     -  (7*Pi**2*Log(2._dp)**3)/72. + (Hm1(y)**2*Log(2._dp)**3)/12. + (Hm11(y)*Log(2._dp)**3)/6. + 
     -  (Hm1(y)*Log(2._dp)**4)/8. - (11*Log(2._dp)**5)/120. + (7*Pi**2*Zeta(3))/32. - 
     -  (7*Hm1(y)**2*Zeta(3))/8. - (7*Hm11(y)*Zeta(3))/4. - 
     -  (21*Log(2._dp)**2*Zeta(3))/16. - (845*Zeta(5))/64.
      
      
      else
      write(*,*)' x out of range HBm101m11.  x = ',x
      endif
      
      return
      end   


      function HBm10011(x) !B22
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10011 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10011 = HB5(-1, 0, 0, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10011 = 2*li5half + HBm100m11(y) + HBm10m101(y) + HBm10m110(y) - HBm11100(y) - 
     -  HBm11m110(y) + 2*HBm1m1001(y) + 2*HBm1m1010(y) + HBm1m10m11(y) + 
     -  HBm1m1100(y) - 2*HBm1m1110(y) + HBm1m11m11(y) - HBm1m1m100(y) + 
     -  3*HBm1m1m101(y) + 3*HBm1m1m111(y) - 3*HBm1m1m1m10(y) - 2*HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/360. - HBm10m11(y)*Hm1(y) + HBm1110(y)*Hm1(y) - 
     -  HBm1m110(y)*Hm1(y) - Hm1(y)**5/120. - (Hm1(y)**3*Hm11(y))/6. + 
     -  Hm1(y)*Hm10(y)*Hm11(y) - Hm100(y)*Hm11(y) + (Hm1(y)*Hm11(y)**2)/2. - 
     -  (Hm1(y)**2*Hm111(y))/2. - Hm11(y)*Hm1m10(y) + (Hm1(y)**2*Hm1m11(y))/2. - 
     -  Hm11(y)*Hm1m11(y) - 2*Hm1(y)*Hm1m12(y) + Hm1(y)*Hm1m1m10(y) + 
     -  2*li4half*Log(2._dp) + (Pi**4*Log(2._dp))/360. + HBm10m11(y)*Log(2._dp) - 
     -  HBm1110(y)*Log(2._dp) + HBm1m110(y)*Log(2._dp) + (Hm1(y)**4*Log(2._dp))/24. + 
     -  (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. - Hm10(y)*Hm11(y)*Log(2._dp) - 
     -  (Hm11(y)**2*Log(2._dp))/2. + Hm1(y)*Hm111(y)*Log(2._dp) - Hm1(y)*Hm1m11(y)*Log(2._dp) + 
     -  2*Hm1m12(y)*Log(2._dp) - Hm1m1m10(y)*Log(2._dp) - (Hm1(y)**3*Log(2._dp)**2)/12. - 
     -  (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. - (Hm111(y)*Log(2._dp)**2)/2. + 
     -  (Hm1m11(y)*Log(2._dp)**2)/2. - (Pi**2*Log(2._dp)**3)/18. + Log(2._dp)**5/15. - 
     -  (7*Pi**2*Zeta(3))/48. + (Hm1(y)**2*Zeta(3))/2. + Hm11(y)*Zeta(3) + 
     -  (7*Log(2._dp)**2*Zeta(3))/8. - (15*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10011.  x = ',x
      endif
      
      return
      end   


      function HBm10010(x) !B23
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm10010 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10010 = HB5(-1, 0, 0, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10010 = 2*HBm101m11(y) + 3*HBm10m111(y) - HBm11111(y) - 3*HBm11m111(y) + 
     -  6*HBm1m1011(y) - 2*HBm1m10m11(y) + HBm1m1101(y) - 6*HBm1m1111(y) - 
     -  HBm1m11m10(y) - 3*HBm1m11m11(y) - 7*HBm1m1m101(y) - 3*HBm1m1m110(y) - 
     -  9*HBm1m1m111(y) + 4*HBm1m1m1m10(y) + 3*HBm1m1m1m11(y) + (Pi**4*Hm1(y))/30. + 
     -  HBm10m11(y)*Hm1(y) - HBm1110(y)*Hm1(y) + HBm1m110(y)*Hm1(y) + 
     -  (Pi**2*Hm1(y)**3)/36. + Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm11(y))/6. + 
     -  (Hm1(y)**3*Hm11(y))/6. - Hm1(y)*Hm10(y)*Hm11(y) - (Hm1(y)*Hm11(y)**2)/2. + 
     -  (Pi**2*Hm111(y))/6. + (Hm1(y)**2*Hm111(y))/2. + Hm10(y)*Hm111(y) + 
     -  Hm11(y)*Hm111(y) - 2*Hm11(y)*Hm12(y) + 2*Hm11(y)*Hm1m10(y) - 
     -  (Pi**2*Hm1m11(y))/6. - (Hm1(y)**2*Hm1m11(y))/2. + 2*Hm11(y)*Hm1m11(y) + 
     -  2*Hm1(y)*Hm1m12(y) - Hm1(y)*Hm1m1m10(y) - (Pi**4*Log(2._dp))/30. + 
     -  (Pi**2*Zeta(3))/16. - Hm1(y)**2*Zeta(3) - 2*Hm11(y)*Zeta(3) + (11*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10010.  x = ',x
      endif
      
      return
      end  
      
      
      function HBm10001(x) !B24
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm10001 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10001 = HB5(-1, 0, 0, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10001 = -HBm101m11(y) - HBm10m111(y) - HBm11110(y) + 2*HBm11m111(y) - 2*HBm1m1011(y) + 
     -  HBm1m10m11(y) + HBm1m1110(y) + 4*HBm1m1111(y) + HBm1m11m10(y) + 
     -  2*HBm1m11m11(y) + 3*HBm1m1m101(y) + 2*HBm1m1m110(y) + 6*HBm1m1m111(y) - 
     -  HBm1m1m1m10(y) - 2*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/90. - HBm1m111(y)*Hm1(y) - 
     -  (Pi**2*Hm1(y)**3)/36. + Hm1(y)**5/120. - (Pi**2*Hm1(y)*Hm11(y))/6. + 
     -  (Hm1(y)**3*Hm11(y))/6. - (Pi**2*Hm111(y))/6. + (Hm1(y)**2*Hm111(y))/2. - 
     -  Hm10(y)*Hm111(y) - Hm11(y)*Hm111(y) + Hm1(y)*Hm1111(y) + Hm11(y)*Hm12(y) - 
     -  Hm11(y)*Hm1m10(y) + (Pi**2*Hm1m11(y))/6. - (Hm1(y)**2*Hm1m11(y))/2. - 
     -  Hm11(y)*Hm1m11(y) + Hm1(y)*Hm1m1m11(y) + (Pi**4*Log(2._dp))/90. + 
     -  HBm1m111(y)*Log(2._dp) - (Hm1(y)**4*Log(2._dp))/24. - (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. - 
     -  Hm1(y)*Hm111(y)*Log(2._dp) - Hm1111(y)*Log(2._dp) + Hm1(y)*Hm1m11(y)*Log(2._dp) - 
     -  Hm1m1m11(y)*Log(2._dp) + (Pi**2*Zeta(3))/8. + (Hm1(y)**2*Zeta(3))/2. + 
     -  Hm11(y)*Zeta(3) - (59*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10001.  x = ',x
      endif
      
      return
      end         



      function HBm10000(x) !B25
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm10000 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10000 = HB5(-1, 0, 0, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10000 = -HBm11111(y) + HBm1m1111(y) - HBm1m1m111(y) + HBm1m1m1m11(y) + 
     -  HBm1m111(y)*Hm1(y) - Hm1(y)**5/120. - (Hm1(y)**3*Hm11(y))/6. - 
     -  (Hm1(y)**2*Hm111(y))/2. - Hm1(y)*Hm1111(y) + (Hm1(y)**2*Hm1m11(y))/2. - 
     -  Hm1(y)*Hm1m1m11(y) + (15*Zeta(5))/16.
      
      else
      write(*,*)' x out of range HBm10000.  x = ',x
      endif
      
      return
      end  
      
      function HBm100m11(x) !B26
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10         
c
      HBm100m11 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm100m11 = HB5(-1, 0, 0, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm100m11 = -4*li5half - HBm101m11(y) - HBm10m111(y) + HBm11m110(y) - 2*HBm1m1011(y) + 
     -  HBm1m10m11(y) + 2*HBm1m1110(y) + HBm1m11m10(y) - HBm1m11m11(y) + 
     -  3*HBm1m1m101(y) + 3*HBm1m1m110(y) - 3*HBm1m1m111(y) - HBm1m1m1m10(y) + 
     -  2*HBm1m1m1m11(y) - 2*li4half*Hm1(y) + (Pi**4*Hm1(y))/180. - 
     -  (Pi**2*Hm1(y)**3)/72. + Hm1(y)**5/120. - (Pi**2*Hm1(y)*Hm11(y))/12. + 
     -  (Hm1(y)**3*Hm11(y))/6. - (Hm1(y)*Hm11(y)**2)/2. - (Pi**2*Hm111(y))/12. + 
     -  (Hm1(y)**2*Hm111(y))/2. - Hm10(y)*Hm111(y) + Hm11(y)*Hm12(y) - 
     -  Hm11(y)*Hm1m10(y) + (Pi**2*Hm1m11(y))/12. - (Hm1(y)**2*Hm1m11(y))/2. + 
     -  Hm11(y)*Hm1m11(y) - (3*Pi**4*Log(2._dp))/160. - (Pi**2*Hm1(y)**2*Log(2._dp))/8. - 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Pi**2*Hm11(y)*Log(2._dp))/4. - 
     -  (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. + (Hm11(y)**2*Log(2._dp))/2. - 
     -  Hm1(y)*Hm111(y)*Log(2._dp) + Hm1(y)*Hm1m11(y)*Log(2._dp) + 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. + (Hm111(y)*Log(2._dp)**2)/2. - 
     -  (Hm1m11(y)*Log(2._dp)**2)/2. - (Pi**2*Log(2._dp)**3)/18. - (Hm1(y)*Log(2._dp)**4)/12. + 
     -  Log(2._dp)**5/30. + (13*Hm1(y)**2*Zeta(3))/16. + (13*Hm11(y)*Zeta(3))/8. + 
     -  (27*Zeta(5))/8.
      
      else
      write(*,*)' x out of range HBm100m11.  x = ',x
      endif
      
      return
      end       


      function HBm10m111(x) !B27
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm10m111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10m111 = HB5(-1, 0, -1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10m111 = -6*li5half + HBm100m11(y) + HBm10m101(y) + HBm10m110(y) + 2*HBm1m1001(y) + 
     -  2*HBm1m1010(y) + HBm1m10m11(y) + 2*HBm1m1100(y) - HBm1m1m100(y) + 
     -  3*HBm1m1m101(y) + 3*HBm1m1m110(y) - 3*HBm1m1m1m10(y) + 4*HBm1m1m1m11(y) - 
     -  3*li4half*Hm1(y) + (11*Pi**4*Hm1(y))/720. - HBm10m11(y)*Hm1(y) - 
     -  2*HBm1m110(y)*Hm1(y) - Hm1(y)**5/120. - (Hm1(y)**3*Hm11(y))/6. + 
     -  Hm1(y)*Hm10(y)*Hm11(y) - Hm100(y)*Hm11(y) - Hm11(y)*Hm1m10(y) + 
     -  Hm1(y)**2*Hm1m11(y) - 2*Hm1(y)*Hm1m12(y) + Hm1(y)*Hm1m1m10(y) - 
     -  3*Hm1(y)*Hm1m1m11(y) + 2*li4half*Log(2._dp) - (77*Pi**4*Log(2._dp))/1440. + 
     -  HBm10m11(y)*Log(2._dp) + 2*HBm1m110(y)*Log(2._dp) - (Pi**2*Hm1(y)**2*Log(2._dp))/24. + 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Pi**2*Hm11(y)*Log(2._dp))/12. + 
     -  (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. - Hm10(y)*Hm11(y)*Log(2._dp) - 
     -  2*Hm1(y)*Hm1m11(y)*Log(2._dp) + 2*Hm1m12(y)*Log(2._dp) - Hm1m1m10(y)*Log(2._dp) + 
     -  3*Hm1m1m11(y)*Log(2._dp) - (Hm1(y)**3*Log(2._dp)**2)/12. - 
     -  (Hm1(y)*Hm11(y)*Log(2._dp)**2)/2. + Hm1m11(y)*Log(2._dp)**2 - (Pi**2*Log(2._dp)**3)/24. + 
     -  (Hm1(y)**2*Log(2._dp)**3)/12. + (Hm11(y)*Log(2._dp)**3)/6. - (Hm1(y)*Log(2._dp)**4)/8. + 
     -  (2*Log(2._dp)**5)/15. - (7*Pi**2*Zeta(3))/32. + (7*Hm1(y)**2*Zeta(3))/16. + 
     -  (7*Hm11(y)*Zeta(3))/8. + (21*Log(2._dp)**2*Zeta(3))/16. + (61*Zeta(5))/8.
      
      else
      write(*,*)' x out of range HBm10m111.  x = ',x
      endif
      
      return
      end   
      

      function HBm10m110(x) !B28
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10m110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10m110 = HB5(-1, 0, -1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10m110 = 16*li5half + HBm101m11(y) + 2*HBm10m111(y) + 4*HBm1m1011(y) - 
     -  2*HBm1m10m11(y) + 2*HBm1m1101(y) - 2*HBm1m11m10(y) - 3*HBm1m11m11(y) - 
     -  7*HBm1m1m101(y) - 6*HBm1m1m110(y) - 6*HBm1m1m111(y) + 4*HBm1m1m1m10(y) - 
     -  3*HBm1m1m1m11(y) + 4*li4half*Hm1(y) - (13*Pi**4*Hm1(y))/1440. + 
     -  HBm10m11(y)*Hm1(y) + 2*HBm1m110(y)*Hm1(y) + (Pi**2*Hm1(y)**3)/36. + 
     -  Hm1(y)**5/120. + (Pi**2*Hm1(y)*Hm11(y))/6. + (Hm1(y)**3*Hm11(y))/6. - 
     -  Hm1(y)*Hm10(y)*Hm11(y) - Hm11(y)*Hm12(y) + 2*Hm11(y)*Hm1m10(y) - 
     -  (Pi**2*Hm1m11(y))/3. - Hm1(y)**2*Hm1m11(y) + Hm11(y)*Hm1m11(y) + 
     -  2*Hm1(y)*Hm1m12(y) - Hm1(y)*Hm1m1m10(y) + 3*Hm1(y)*Hm1m1m11(y) + 
     -  4*li4half*Log(2._dp) + (119*Pi**4*Log(2._dp))/1440. + (Pi**2*Hm1(y)**2*Log(2._dp))/24. + 
     -  (Pi**2*Hm11(y)*Log(2._dp))/12. - (Pi**2*Hm1(y)*Log(2._dp)**2)/6. + 
     -  (Pi**2*Log(2._dp)**3)/18. + (Hm1(y)*Log(2._dp)**4)/6. + Log(2._dp)**5/30. + 
     -  (Pi**2*Zeta(3))/12. - (Hm1(y)**2*Zeta(3))/2. - Hm11(y)*Zeta(3) - 
     -  (507*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10m110.  x = ',x
      endif
      
      return
      end              


      function HBm10m101(x) !B29
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm10m101 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10m101 = HB5(-1, 0, -1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10m101 = -4*li5half - HBm11m110(y) + HBm1m10m11(y) + 2*HBm1m11m10(y) + 
     -  4*HBm1m11m11(y) + 3*HBm1m1m101(y) + 2*HBm1m1m110(y) + 12*HBm1m1m111(y) - 
     -  HBm1m1m1m10(y) - 8*HBm1m1m1m11(y) - (Pi**4*Hm1(y))/480. - 
     -  2*HBm1m111(y)*Hm1(y) - (Pi**2*Hm1(y)**3)/36. + Hm1(y)**5/120. - 
     -  (Pi**2*Hm1(y)*Hm11(y))/6. + (Hm1(y)**3*Hm11(y))/6. + (Hm1(y)*Hm11(y)**2)/2. - 
     -  Hm11(y)*Hm1m10(y) + (Pi**2*Hm1m11(y))/3. - Hm1(y)**2*Hm1m11(y) - 
     -  2*Hm11(y)*Hm1m11(y) + 4*Hm1(y)*Hm1m1m11(y) - 4*li4half*Log(2._dp) + 
     -  (Pi**4*Log(2._dp))/480. + 2*HBm1m111(y)*Log(2._dp) + (Pi**2*Hm1(y)**2*Log(2._dp))/12. - 
     -  (Hm1(y)**4*Log(2._dp))/24. + (Pi**2*Hm11(y)*Log(2._dp))/6. - 
     -  (Hm1(y)**2*Hm11(y)*Log(2._dp))/2. - (Hm11(y)**2*Log(2._dp))/2. + 
     -  2*Hm1(y)*Hm1m11(y)*Log(2._dp) - 4*Hm1m1m11(y)*Log(2._dp) + (Pi**2*Log(2._dp)**3)/9. - 
     -  (2*Log(2._dp)**5)/15. + (Pi**2*Zeta(3))/4. - (5*Hm1(y)**2*Zeta(3))/16. - 
     -  (5*Hm11(y)*Zeta(3))/8. - (7*Log(2._dp)**2*Zeta(3))/4. + (33*Zeta(5))/32.
      
      
      else
      write(*,*)' x out of range HBm10m101.  x = ',x
      endif
      
      return
      end      


      function HBm10m100(x) !B30
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10  
c
      HBm10m100 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm10m100 = HB5(-1, 0, -1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm10m100 = -HBm11m111(y) - HBm1m11m11(y) - 7*HBm1m1m111(y) + 7*HBm1m1m1m11(y) - 
     -  (7*Pi**4*Hm1(y))/240. + 2*HBm1m111(y)*Hm1(y) - Hm1(y)**5/120. - 
     -  (Hm1(y)**3*Hm11(y))/6. - (Hm1(y)*Hm11(y)**2)/2. + Hm1(y)**2*Hm1m11(y) + 
     -  Hm11(y)*Hm1m11(y) - 4*Hm1(y)*Hm1m1m11(y) + (7*Pi**4*Log(2._dp))/240. - 
     -  (Pi**2*Zeta(3))/6. + (3*Hm1(y)**2*Zeta(3))/8. + (3*Hm11(y)*Zeta(3))/4. + 
     -  (41*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm10m100.  x = ',x
      endif
      
      return
      end      


      function HBm1m1111(x) !B31
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10    
c
      HBm1m1111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1111 = HB5(-1, -1, 1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1111 = li5half - HBm1m1000(y) - 2*HBm1m1m100(y) - 3*HBm1m1m1m10(y) - li4half*Hm1(y) + 
     -  Hm1(y)**5/120. - (Hm1(y)**2*Hm1m10(y))/2. + Hm1(y)*Hm1m100(y) + 
     -  2*Hm1(y)*Hm1m1m10(y) + li4half*Log(2._dp) - (Pi**4*Log(2._dp))/720. - 
     -  (Hm1(y)**4*Log(2._dp))/24. + Hm1(y)*Hm1m10(y)*Log(2._dp) - Hm1m100(y)*Log(2._dp) - 
     -  2*Hm1m1m10(y)*Log(2._dp) + (Hm1(y)**3*Log(2._dp)**2)/12. - (Hm1m10(y)*Log(2._dp)**2)/2. - 
     -  (Pi**2*Log(2._dp)**3)/36. - (Hm1(y)**2*Log(2._dp)**3)/12. + Log(2._dp)**5/40. - 
     -  (Pi**2*Zeta(3))/12. + (Log(2._dp)**2*Zeta(3))/2. + Zeta(5)/32.
      
      else
      write(*,*)' x out of range HBm1m1111.  x = ',x
      endif
      
      return
      end   



      function HBm1m1110(x) !B32
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10    
c
      HBm1m1110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1110 = HB5(-1, -1, 1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1110 = 4*li5half - HBm1m1001(y) + HBm1m10m10(y) + HBm1m10m11(y) + 3*HBm1m1m100(y) + 
     -  HBm1m1m101(y) + 2*HBm1m1m1m10(y) - HBm1m1m1m11(y) + li4half*Hm1(y) + 
     -  (Pi**4*Hm1(y))/720. - (Pi**2*Hm1(y)**3)/36. - Hm1(y)**5/120. + 
     -  (Pi**2*Hm1m10(y))/6. + (Hm1(y)**2*Hm1m10(y))/2. - Hm1(y)*Hm1m100(y) - 
     -  2*Hm1(y)*Hm1m1m10(y) + 2*li4half*Log(2._dp) + (7*Pi**4*Log(2._dp))/288. + 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/12. - (Pi**2*Log(2._dp)**3)/24. + 
     -  (Hm1(y)*Log(2._dp)**4)/24. + Log(2._dp)**5/20. + (Pi**2*Zeta(3))/96. + 
     -  (Hm1(y)**2*Zeta(3))/2. - (Hm1(y)*Log(2._dp)*Zeta(3))/8. + 
     -  (Log(2._dp)**2*Zeta(3))/16. - (277*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm1m1110.  x = ',x
      endif
      
      return
      end  
      
      
      function HBm1m1101(x) !B33
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm1m1101 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1101 = HB5(-1, -1, 1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1101= -4*li5half - HBm1m1010(y) - HBm1m10m10(y) - HBm1m10m11(y) - 3*HBm1m1m101(y) + 
     -  HBm1m1m110(y) + 7*HBm1m1m1m10(y) + 4*HBm1m1m1m11(y) + li4half*Hm1(y) - 
     -  (19*Pi**4*Hm1(y))/1440. + (Pi**2*Hm1(y)**3)/36. - Hm1(y)**5/120. - 
     -  (Pi**2*Hm1m10(y))/6. + (Hm1(y)**2*Hm1m10(y))/2. + Hm1(y)*Hm1m12(y) - 
     -  3*Hm1(y)*Hm1m1m10(y) - Hm1(y)*Hm1m1m11(y) - 4*li4half*Log(2._dp) - 
     -  (Pi**4*Log(2._dp))/480. - (Pi**2*Hm1(y)**2*Log(2._dp))/12. + (Hm1(y)**4*Log(2._dp))/24. - 
     -  Hm1(y)*Hm1m10(y)*Log(2._dp) - Hm1m12(y)*Log(2._dp) + 3*Hm1m1m10(y)*Log(2._dp) + 
     -  Hm1m1m11(y)*Log(2._dp) + (Pi**2*Hm1(y)*Log(2._dp)**2)/24. + (Pi**2*Log(2._dp)**3)/12. + 
     -  (Hm1(y)*Log(2._dp)**4)/24. - (2*Log(2._dp)**5)/15. + (23*Pi**2*Zeta(3))/96. - 
     -  Hm1(y)**2*Zeta(3) + (Hm1(y)*Log(2._dp)*Zeta(3))/4. - (23*Log(2._dp)**2*Zeta(3))/16. + 
     -  (85*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm1m1101.  x = ',x
      endif
      
      return
      end  
      
      function HBm1m1100(x) !B34
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10    
c
      HBm1m1100 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1100 = HB5(-1, -1, 1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1100= -4*li5half - HBm1m1011(y) + 3*HBm1m1m101(y) + HBm1m1m111(y) - 
     -  6*HBm1m1m1m10(y) - 3*HBm1m1m1m11(y) - (19*Pi**4*Hm1(y))/1440. + 
     -  Hm1(y)**5/120. - (Hm1(y)**2*Hm1m10(y))/2. - Hm1(y)*Hm1m12(y) + 
     -  3*Hm1(y)*Hm1m1m10(y) + Hm1(y)*Hm1m1m11(y) - 2*li4half*Log(2._dp) - 
     -  (Pi**4*Log(2._dp))/48. + (Pi**2*Log(2._dp)**3)/36. - Log(2._dp)**5/20. - 
     -  (13*Pi**2*Zeta(3))/96. + (Hm1(y)**2*Zeta(3))/2. + 
     -  (3*Hm1(y)*Log(2._dp)*Zeta(3))/4. - (3*Log(2._dp)**2*Zeta(3))/8. + (47*Zeta(5))/8.
      
      else
      write(*,*)' x out of range HBm1m1100.  x = ',x
      endif
      
      return
      end               


      function HBm1m11m11(x) !B35
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10      
c
      HBm1m11m11 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m11m11 = HB5(-1, -1, 1, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m11m11 = 3*li5half - HBm1m10m10(y) + 7*HBm1m1m1m10(y) - (Pi**4*Hm1(y))/1440. + 
     -  (Pi**2*Hm1(y)**3)/72. - Hm1(y)**5/120. - (Pi**2*Hm1m10(y))/12. + 
     -  (Hm1(y)**2*Hm1m10(y))/2. - 3*Hm1(y)*Hm1m1m10(y) + (Pi**4*Log(2._dp))/30. + 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Hm1(y)**4*Log(2._dp))/24. - 
     -  Hm1(y)*Hm1m10(y)*Log(2._dp) + 3*Hm1m1m10(y)*Log(2._dp) + 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/24. - (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1m10(y)*Log(2._dp)**2)/2. + (Pi**2*Log(2._dp)**3)/24. + (Hm1(y)**2*Log(2._dp)**3)/12. - 
     -  (Hm1(y)*Log(2._dp)**4)/24. - Log(2._dp)**5/60. + (Pi**2*Zeta(3))/4. - 
     -  (7*Hm1(y)**2*Zeta(3))/8. - (Hm1(y)*Log(2._dp)*Zeta(3))/4. - 
     -  (11*Log(2._dp)**2*Zeta(3))/8. - (375*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm1m11m11.  x = ',x
      endif
      
      return
      end               


      function HBm1m11m10(x) !B36
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm1m11m10 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m11m10 = HB5(-1, -1, 1, -1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m11m10 = -5*li5half - HBm1m10m11(y) - 6*HBm1m1m1m10(y) + HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/360. - (Pi**2*Hm1(y)**3)/72. + Hm1(y)**5/120. + 
     -  (Pi**2*Hm1m10(y))/12. - (Hm1(y)**2*Hm1m10(y))/2. + 3*Hm1(y)*Hm1m1m10(y) - 
     -  3*li4half*Log(2._dp) - (7*Pi**4*Log(2._dp))/288. - (Pi**2*Hm1(y)**2*Log(2._dp))/12. - 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/24. + (5*Pi**2*Log(2._dp)**3)/72. - Log(2._dp)**5/12. - 
     -  (11*Pi**2*Zeta(3))/48. + (13*Hm1(y)**2*Zeta(3))/16. + Hm1(y)*Log(2._dp)*Zeta(3) - 
     -  (Log(2._dp)**2*Zeta(3))/2. + (247*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m11m10.  x = ',x
      endif
      
      return
      end  


      function HBm1m1011(x) !B37
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm1m1011 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1011 = HB5(-1, -1, 0, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1011 = li5half - HBm1m1100(y) - HBm1m1m100(y) - 3*HBm1m1m110(y) - 3*HBm1m1m1m10(y) - 
     -  6*HBm1m1m1m11(y) + li4half*Hm1(y) - (Pi**4*Hm1(y))/288. + HBm1m110(y)*Hm1(y) - 
     -  Hm1(y)**5/120. - (Hm1(y)**2*Hm1m11(y))/2. + Hm1(y)*Hm1m1m10(y) + 
     -  3*Hm1(y)*Hm1m1m11(y) + (Pi**4*Log(2._dp))/288. - HBm1m110(y)*Log(2._dp) + 
     -  (Hm1(y)**4*Log(2._dp))/24. + Hm1(y)*Hm1m11(y)*Log(2._dp) - Hm1m1m10(y)*Log(2._dp) - 
     -  3*Hm1m1m11(y)*Log(2._dp) - (Pi**2*Hm1(y)*Log(2._dp)**2)/24. - 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. - (Hm1m11(y)*Log(2._dp)**2)/2. + (Pi**2*Log(2._dp)**3)/72. + 
     -  (Hm1(y)*Log(2._dp)**4)/24. - Log(2._dp)**5/120. + (Hm1(y)**2*Zeta(3))/2. - 
     -  (Hm1(y)*Log(2._dp)*Zeta(3))/8. + (Log(2._dp)**2*Zeta(3))/16. - (25*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m1011.  x = ',x
      endif
      
      return
      end  
      
      function HBm1m1010(x) !B38
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10      
c
      HBm1m1010 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1010 = HB5(-1, -1, 0, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1010 = -4*li5half - HBm1m1101(y) + HBm1m11m10(y) + HBm1m11m11(y) - HBm1m1m101(y) + 
     -  3*HBm1m1m110(y) + 4*HBm1m1m1m10(y) + 7*HBm1m1m1m11(y) - 4*li4half*Hm1(y) + 
     -  (17*Pi**4*Hm1(y))/480. - HBm1m110(y)*Hm1(y) + (Pi**2*Hm1(y)**3)/36. + 
     -  Hm1(y)**5/120. + (Pi**2*Hm1m11(y))/6. + (Hm1(y)**2*Hm1m11(y))/2. - 
     -  Hm1(y)*Hm1m1m10(y) - 3*Hm1(y)*Hm1m1m11(y) - (17*Pi**4*Log(2._dp))/480. + 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/6. - (Pi**2*Log(2._dp)**3)/18. - (Hm1(y)*Log(2._dp)**4)/6. + 
     -  Log(2._dp)**5/30. + (5*Pi**2*Zeta(3))/96. - Hm1(y)**2*Zeta(3) - 
     -  (3*Hm1(y)*Log(2._dp)*Zeta(3))/2. + (3*Log(2._dp)**2*Zeta(3))/4. + (103*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m1010.  x = ',x
      endif
      
      return
      end        
      
      function HBm1m1001(x) !B39
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10     
c
      HBm1m1001 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1001 = HB5(-1, -1, 0, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1001 = 4*li5half - HBm1m1110(y) - HBm1m11m10(y) - HBm1m11m11(y) - HBm1m1m110(y) - 
     -  3*HBm1m1m111(y) - HBm1m1m1m10(y) + 2*HBm1m1m1m11(y) + 2*li4half*Hm1(y) - 
     -  (Pi**4*Hm1(y))/60. + HBm1m111(y)*Hm1(y) - (Pi**2*Hm1(y)**3)/36. + 
     -  Hm1(y)**5/120. - (Pi**2*Hm1m11(y))/6. + (Hm1(y)**2*Hm1m11(y))/2. - 
     -  2*Hm1(y)*Hm1m1m11(y) + 2*li4half*Log(2._dp) + (Pi**4*Log(2._dp))/60. - 
     -  HBm1m111(y)*Log(2._dp) - (Hm1(y)**4*Log(2._dp))/24. - Hm1(y)*Hm1m11(y)*Log(2._dp) + 
     -  2*Hm1m1m11(y)*Log(2._dp) - (Pi**2*Hm1(y)*Log(2._dp)**2)/12. - (Pi**2*Log(2._dp)**3)/36. + 
     -  (Hm1(y)*Log(2._dp)**4)/12. + Log(2._dp)**5/20. - (Pi**2*Zeta(3))/8. + 
     -  (Hm1(y)**2*Zeta(3))/2. + (3*Hm1(y)*Log(2._dp)*Zeta(3))/4. + 
     -  (Log(2._dp)**2*Zeta(3))/2. - (39*Zeta(5))/16.
      
      else
      write(*,*)' x out of range HBm1m1001.  x = ',x
      endif
      
      return
      end  


      function HBm1m1000(x) !B40
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10    
c
      HBm1m1000 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1000 = HB5(-1, -1, 0, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1000 = -HBm1m1111(y) + 2*HBm1m1m111(y) - 3*HBm1m1m1m11(y) + (7*Pi**4*Hm1(y))/720. - 
     -  HBm1m111(y)*Hm1(y) - Hm1(y)**5/120. - (Hm1(y)**2*Hm1m11(y))/2. + 
     -  2*Hm1(y)*Hm1m1m11(y) - (7*Pi**4*Log(2._dp))/720. + (Pi**2*Zeta(3))/12. - 
     -  (29*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m1000.  x = ',x
      endif
      
      return
      end 


      function HBm1m10m11(x) !B41
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10  
c
      HBm1m10m11 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m10m11 = HB5(-1, -1, 0, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m10m11 = -HBm1m11m10(y) - HBm1m1m1m10(y) + 6*HBm1m1m1m11(y) + 4*li4half*Hm1(y) - 
     -  (5*Pi**4*Hm1(y))/144. - (Pi**2*Hm1(y)**3)/72. + Hm1(y)**5/120. - 
     -  (Pi**2*Hm1m11(y))/12. + (Hm1(y)**2*Hm1m11(y))/2. - 3*Hm1(y)*Hm1m1m11(y) - 
     -  li4half*Log(2._dp) - (Pi**4*Log(2._dp))/1440. - (Pi**2*Hm1(y)**2*Log(2._dp))/8. - 
     -  (Hm1(y)**4*Log(2._dp))/24. - Hm1(y)*Hm1m11(y)*Log(2._dp) + 3*Hm1m1m11(y)*Log(2._dp) + 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + (Hm1(y)**3*Log(2._dp)**2)/12. + 
     -  (Hm1m11(y)*Log(2._dp)**2)/2. - (Pi**2*Log(2._dp)**3)/12. + (Hm1(y)*Log(2._dp)**4)/6. - 
     -  Log(2._dp)**5/24. - (7*Pi**2*Zeta(3))/32. + (13*Hm1(y)**2*Zeta(3))/16. + 
     -  Hm1(y)*Log(2._dp)*Zeta(3) + (13*Log(2._dp)**2*Zeta(3))/16. + (87*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m10m11.  x = ',x
      endif
      
      return
      end 


      function HBm1m10m10(x) !B42
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10        
c
      HBm1m10m10 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m10m10 = HB5(-1, -1, 0, -1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m10m10 = -4*li5half - HBm1m11m11(y) - 7*HBm1m1m1m11(y) - 4*li4half*Hm1(y) + 
     -  (11*Pi**4*Hm1(y))/288. + (Pi**2*Hm1(y)**3)/72. - Hm1(y)**5/120. + 
     -  (Pi**2*Hm1m11(y))/12. - (Hm1(y)**2*Hm1m11(y))/2. + 3*Hm1(y)*Hm1m1m11(y) - 
     -  (11*Pi**4*Log(2._dp))/288. + (Pi**2*Hm1(y)*Log(2._dp)**2)/6. - (Pi**2*Log(2._dp)**3)/18. - 
     -  (Hm1(y)*Log(2._dp)**4)/6. + Log(2._dp)**5/30. + (23*Pi**2*Zeta(3))/96. - 
     -  (3*Hm1(y)**2*Zeta(3))/4. - 2*Hm1(y)*Log(2._dp)*Zeta(3) + Log(2._dp)**2*Zeta(3) + 
     -  (73*Zeta(5))/64.
      
      else
      write(*,*)' x out of range HBm1m10m10.  x = ',x
      endif
      
      return
      end 


      function HBm1m1m111(x) !B43
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10    
c
      HBm1m1m111 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m111 = HB5(-1, -1, -1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m111 = -li5half - HBm1m1m100(y) - 3*HBm1m1m1m10(y) - (Pi**4*Hm1(y))/720. - 
     -  Hm1(y)**5/120. + Hm1(y)*Hm1m1m10(y) - (Pi**4*Log(2._dp))/90. - 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Hm1(y)**4*Log(2._dp))/24. - Hm1m1m10(y)*Log(2._dp) - 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. - (Pi**2*Log(2._dp)**3)/72. + 
     -  (Hm1(y)**2*Log(2._dp)**3)/12. - (Hm1(y)*Log(2._dp)**4)/24. + Log(2._dp)**5/60. - 
     -  (Pi**2*Zeta(3))/12. + (7*Hm1(y)**2*Zeta(3))/16. + (Hm1(y)*Log(2._dp)*Zeta(3))/8. + 
     -  (7*Log(2._dp)**2*Zeta(3))/16. + (63*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m1m111.  x = ',x
      endif
      
      return
      end 


      function HBm1m1m110(x) !B44
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10  
c
      HBm1m1m110 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m110 = HB5(-1, -1, -1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m110 = 4*li5half - HBm1m1m101(y) + 4*HBm1m1m1m10(y) + HBm1m1m1m11(y) - 
     -  2*li4half*Hm1(y) + (7*Pi**4*Hm1(y))/288. + (Pi**2*Hm1(y)**3)/36. + 
     -  Hm1(y)**5/120. - Hm1(y)*Hm1m1m10(y) + 3*li4half*Log(2._dp) + (Pi**4*Log(2._dp))/90. + 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Pi**2*Hm1(y)*Log(2._dp)**2)/24. - 
     -  (Pi**2*Log(2._dp)**3)/18. - (Hm1(y)*Log(2._dp)**4)/12. + (11*Log(2._dp)**5)/120. + 
     -  (7*Pi**2*Zeta(3))/96. - (Hm1(y)**2*Zeta(3))/2. - 
     -  (13*Hm1(y)*Log(2._dp)*Zeta(3))/8. + (13*Log(2._dp)**2*Zeta(3))/16. - (39*Zeta(5))/8. 
      
      else
      write(*,*)' x out of range HBm1m1m110.  x = ',x
      endif
      
      return
      end 
      
      
      function HBm1m1m101(x) !B45
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10  
c
      HBm1m1m101 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m101 = HB5(-1, -1, -1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m101 = -li5half - HBm1m1m110(y) - HBm1m1m1m10(y) - 4*HBm1m1m1m11(y) - 
     -  (Pi**4*Hm1(y))/480. - (Pi**2*Hm1(y)**3)/36. + Hm1(y)**5/120. + 
     -  Hm1(y)*Hm1m1m11(y) - li4half*Log(2._dp) + (Pi**4*Log(2._dp))/480. + 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/12. - (Hm1(y)**4*Log(2._dp))/24. - Hm1m1m11(y)*Log(2._dp) - 
     -  (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + (Pi**2*Log(2._dp)**3)/18. - Log(2._dp)**5/30. + 
     -  (7*Pi**2*Zeta(3))/96. - (5*Hm1(y)**2*Zeta(3))/16. + 
     -  (5*Hm1(y)*Log(2._dp)*Zeta(3))/8. - (3*Log(2._dp)**2*Zeta(3))/4. + Zeta(5)/8.
      
      else
      write(*,*)' x out of range HBm1m1m101.  x = ',x
      endif
      
      return
      end 
      
      
      function HBm1m1m100(x) !B46
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m1m11,HBm1m1m1m10      
c
      HBm1m1m100 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m100 = HB5(-1, -1, -1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m100 = 2*li5half - HBm1m1m111(y) + 3*HBm1m1m1m11(y) + 2*li4half*Hm1(y) - 
     -  (Pi**4*Hm1(y))/48. - Hm1(y)**5/120. - Hm1(y)*Hm1m1m11(y) + 
     -  (Pi**4*Log(2._dp))/48. - (Pi**2*Hm1(y)*Log(2._dp)**2)/12. + (Pi**2*Log(2._dp)**3)/36. + 
     -  (Hm1(y)*Log(2._dp)**4)/12. - Log(2._dp)**5/60. - (Pi**2*Zeta(3))/12. + 
     -  (3*Hm1(y)**2*Zeta(3))/8. + Hm1(y)*Log(2._dp)*Zeta(3) - (Log(2._dp)**2*Zeta(3))/2. - 
     -  (33*Zeta(5))/32.
      
      else
      write(*,*)' x out of range HBm1m1m100.  x = ',x
      endif
      
      return
      end            



      function HBm1m1m1m11(x) !B47
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m10    
c
      HBm1m1m1m11 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m1m11 = HB5(-1, -1, -1, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m1m11 = -li5half - HBm1m1m1m10(y) + li4half*Hm1(y) - (Pi**4*Hm1(y))/90. - 
     -  (Pi**2*Hm1(y)**3)/72. + Hm1(y)**5/120. - li4half*Log(2._dp) - 
     -  (Hm1(y)**4*Log(2._dp))/24. - (Pi**2*Hm1(y)*Log(2._dp)**2)/24. + 
     -  (Hm1(y)**3*Log(2._dp)**2)/12. + (Pi**2*Log(2._dp)**3)/36. - 
     -  (Hm1(y)**2*Log(2._dp)**3)/12. + (Hm1(y)*Log(2._dp)**4)/12. - Log(2._dp)**5/24. + 
     -  (Hm1(y)**2*Zeta(3))/16. + (7*Hm1(y)*Log(2._dp)*Zeta(3))/8. - 
     -  (7*Log(2._dp)**2*Zeta(3))/16. + Zeta(5)
      
      else
      write(*,*)' x out of range HBm1m1m1m11.  x = ',x
      endif
      
      return
      end         


      function HBm1m1m1m10(x) !B48
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_Basis_4.f'
      real(dp):: x,myli2,myli3,myli4,Zeta,y,li4half,li5half
      external Zeta
      external myli3
      external myli2,myli4
c
      REAL*8   HB1,HB2,HB3,HB4,HB5
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB1,HB2,HB3,HB4,HB5
      real(dp):: HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      real(dp):: HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c     
      real(dp):: HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      real(dp):: HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000
c
      real(dp):: HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11,HBm1m1m1m10
c
      external HBm11100,HBm11101,HBm11110,HBm11111,HB00001,HB00011,
     & HB00101,HB00111,HB01011,HB01111
c
      external HBm11011,HBm11010,HBm11001,HBm11000,HBm11m111,
     & HBm11m110,HBm10111,HBm10110,HBm10101,HBm10100
c
      external HBm101m11,HBm10011,HBm10010,HBm10001,HBm10000,
     & HBm100m11,HBm10m111,HBm10m110,HBm10m101,HBm10m100
c
      external HBm1m1111,HBm1m1110,HBm1m1101,HBm1m1100,HBm1m11m11,
     & HBm1m11m10,HBm1m1011,HBm1m1010,HBm1m1001,HBm1m1000 
c
      external HBm1m10m11,HBm1m10m10,HBm1m1m111,HBm1m1m110,HBm1m1m101,
     & HBm1m1m100,HBm1m1m1m11    
c
      HBm1m1m1m10 = zip
      li4half = 0.5174790616738993_dp
      li5half = 0.5084005792422687_dp
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      HBm1m1m1m10 = HB5(-1, -1, -1, -1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      HBm1m1m1m10 =-li5half - HBm1m1m1m11(y) - li4half*Hm1(y) + (Pi**4*Hm1(y))/90. + 
     -  (Pi**2*Hm1(y)**3)/72. - Hm1(y)**5/120. - (Pi**4*Log(2._dp))/90. - 
     -  (Pi**2*Hm1(y)**2*Log(2._dp))/24. + (Pi**2*Hm1(y)*Log(2._dp)**2)/12. - 
     -  (Pi**2*Log(2._dp)**3)/36. - (Hm1(y)*Log(2._dp)**4)/24. + Log(2._dp)**5/120. + 
     -  (Hm1(y)**2*Zeta(3))/16. - Hm1(y)*Log(2._dp)*Zeta(3) + (Log(2._dp)**2*Zeta(3))/2. + 
     -  Zeta(5)
      
      else
      write(*,*)' x out of range HBm1m1m1m10.  x = ',x
      endif
      
      return
      end        
